(*
* Copyright (C) 2007 Universitaet Koblenz-Landau
* 
* This file is part of E-KRHyper.
* 
* E-KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* E-KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* E-KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>,
*                 Bjoern Pelzer <bpelzer@uni-koblenz.de>.
*)


let tptp_parser cfg input =
	let next_clause lexbuf = 
		try	
			(Some 
				(TptpParser.tptp_input
					TptpLexer.token
					lexbuf))
		with 
			| Err.END_OF_FILE -> (None)	
			| Err.END_OF_FILE_WITH_DATA (fof, conjecture) ->
				(Cfg.set_szs_fof_flag cfg fof;
				Cfg.set_szs_conjecture_flag cfg conjecture;
				None)
	in
	    Stream.from 
	    	(fun count -> next_clause input)