/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package chercher;

import java.util.HashMap;

/**
 *
 * @author ertri
 */
public class IntegerForest extends HashMap<IntegerTree, IntegerTree>{
    public static long hits = 0;
    public static long accesses = 0;
    
    public final  void inca() {
        accesses++;
    }
    
    public final  void inch() {
        hits++;
    }
    public IntegerTree getIntegerTree(int[][] coefficients, int[] bound, boolean[] tightable, int[] vbound) {
        IntegerTree intT = new IntegerTree(coefficients, bound, tightable, vbound);
        inca();
        if(this.containsKey(intT)) {
            inch();
            return this.get(intT);
        } else {
            this.put(intT, intT);
            return intT;
        }
    }
    public static synchronized long getAccesses() {
        return accesses;
    }
    
    public static synchronized long getHits() {
        return hits;
    }
}
