/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package concurrent;

public interface Task<I, O> {
	boolean hasNext();

	boolean input(I input);

	TaskInstance<O> next();

	public interface TaskInstance<O> {
		O run() throws SearchFailureException;
	}

	public enum Type {
		ANALYZER, SIMPLE, SYNTHESIZER
	}

	public interface TypeToken {
		Type getTaskType();
	}

	public class SimpleTypeToken implements TypeToken {

		public Type getTaskType() {
			return Type.SIMPLE;
		}

	}
	
	public class AnalyzerTypeToken implements TypeToken {
		public Type getTaskType() {
			return Type.ANALYZER;
		}
	}
	
	public class SynthesizerTypeToken implements TypeToken {

		public Type getTaskType() {
			return Type.SYNTHESIZER;
		}
		
	}

}
