/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.constraint;

import java.util.*;

import jfp.dynamic.ExtensibleAST;
import jfp.type.Util;

public class Constraint {

	ConstraintType consType;
	List components;
	public Constraint(ConstraintType consType, Object... components) {
		super();
		this.consType = consType;
		this.components = Arrays.asList(components);
	}

	public Constraint(ConstraintType consType) {
		super();
		this.consType = consType;
		this.components = new ArrayList();
	}

	public ExtensibleAST getLB() {
		return Util.wrap(components.get(0));
	}
	
	public ExtensibleAST getUB() {
		return Util.wrap(components.get(1));
	}
}
