/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.dynamic;

import java.util.HashMap;
import java.util.Map;

import jfp.dynamic.east.VisitorParameters;
import jfp.environment.GenericEnvironment;

public abstract class ExtensibleASTDelegate<EA extends ExtensibleAST> {
    // ExtensibleAST ast;
    ExtensibleASTDelegate delegate;

    public Object visitedBy(String visitor, EA ast, VisitorParameters param) throws ASTException {

        GenericEnvironment<String, Object> env = param.getEnv();
        ExtensibleAST[] extensibleAST = param.getEASTArray();
        GenericEnvironment<String, Object>[] interface1 = param.getEnvArray();
        if (delegate != null) {
            return delegate.visitedBy(visitor, ast, new VisitorParameters(env, extensibleAST,
                    interface1));
        } else {
            return doVisitedBy(visitor, ast, env, extensibleAST, interface1);
        }
    }

    public Object doVisitedBy(String visitor, EA ast, VisitorParameters params) throws ASTException {
        return this.doVisitedBy(visitor, ast, params.getEnv(), 
                params.getEASTArray(), params.getEnvArray()
                );

    }

    protected abstract Object doVisitedBy(String visitor, EA ast,
            GenericEnvironment<String, Object> env, ExtensibleAST[] astn,
            GenericEnvironment<String, Object>[] envn) throws ASTException;
}
