/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.type;

import java.util.ArrayList;
import java.util.List;

import jfp.datatype.Pair;
import jfp.dynamic.Term;
import jfp.dynamic.ASTException;
import jfp.dynamic.ExtensibleAST;
import jfp.dynamic.TypeASTDelegate;
import jfp.environment.TypeVariableEnvironmentInterface;

public class TDUDelegate extends TypeASTDelegate {

	@Override
	public Object unify_env(ExtensibleAST domainType,
			TypeVariableEnvironmentInterface vp, ExtensibleAST valueType,
			TypeVariableEnvironmentInterface vp2) throws ASTException {
		if (valueType instanceof TDisjointUnion) {
			TDisjointUnion dt = (TDisjointUnion) domainType;
			TDisjointUnion vt = (TDisjointUnion) valueType;
			if (dt.genericType.equals(vt.genericType)) {
				for (int i = 0; i < dt.typeParameters.length; i++) {
					if (!Util.unifiable(dt.typeParameters[i],
							 vp,
							vt.typeParameters[i],
							 vp2))
						return false;
				}
				return true;
			}
		}
		return false;
	}

	@Override
	public Object type_varaibles(ExtensibleAST ast, TypeVariableEnvironmentInterface env)
			throws ASTException {
		return null;
	}

	@Override
	public Object instantiate(ExtensibleAST value, TypeVariableEnvironmentInterface env)
			throws ASTException {
		TDisjointUnion t = (TDisjointUnion) value;
		ArrayList list = new ArrayList();
		for (int i = 0; i < t.typeParameters.length; i++) {
			list.add(Util.getTypeInstance(t.typeParameters[i], env));
		}
		return new TDisjointUnion(t.genericType, list.toArray());
	}


	@Override
	public Object inst(ExtensibleAST ast, TypeVariableEnvironmentInterface env) throws ASTException {
		TDisjointUnion type = (TDisjointUnion) ast;
		Object[] a = new Object[type.genericType.arity];
		for(int i = 0;i<type.genericType.arity;i++) {
			Object t = type.typeParameters[i];
			a[i]=Util.wrap(t).visitedBy(Term.INST, env);
		}
		return new TDisjointUnion(type.genericType,a);
	}
}
