/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.type;

import java.util.ArrayList;
import java.util.List;

import jfp.datatype.Pair;
import jfp.dynamic.Term;
import jfp.dynamic.ASTException;
import jfp.dynamic.ExtensibleAST;
import jfp.dynamic.TypeASTDelegate;
import jfp.environment.TypeVariableEnvironmentInterface;

public class TListDelegate extends TypeASTDelegate {

	@Override
	public Object unify_env(ExtensibleAST domainType,
			TypeVariableEnvironmentInterface vp, ExtensibleAST valueType,
			TypeVariableEnvironmentInterface vp2) throws ASTException {
		return Util.unifiable(((TList) domainType).getElementType(),
				(TypeVariableEnvironmentInterface) vp, ((TList) valueType)
						.getElementType(), (TypeVariableEnvironmentInterface) vp2);
	}

	@Override
	public Object type_varaibles(ExtensibleAST ast, TypeVariableEnvironmentInterface env)
			throws ASTException {
		return Util.definedTypeVariables(((TList) ast).getElementType());
	}

	@Override
	public Object instantiate(ExtensibleAST ast, TypeVariableEnvironmentInterface env)
			throws ASTException {
		Object elt = ((TList) ast).getElementType();
		return new TList(Util.getTypeInstance(elt, env));
	}


	@Override
	public Object inst(ExtensibleAST ast, TypeVariableEnvironmentInterface env) throws ASTException {
		return new TList(Util.wrap(((TList)ast).getElementType()).visitedBy(Term.INST, env));
	}

}
