/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.concurrent.data;

import java.util.Comparator;
import java.util.Iterator;

import logic.data.Clause;
import logic.data.Literal;

public class ClauseComparator implements Comparator<Clause> {

	public int compare(Clause next, Clause clause) {
		return compareClauses(next, clause);
	}
	
	public static int compareClauses(Clause c, Clause d) {
		Iterator<Literal> itc = c.descendingIterator();
		Iterator<Literal> itd = d.descendingIterator();
		while(itc.hasNext()&&itd.hasNext()) {
			Literal cm = itc.next();
			Literal dm = itd.next();
			int cmp = Clause.LiteralLSCptr.instance.compare(cm, dm);
			if(cmp!=0)
				return cmp; 
		}
		if(itc.hasNext())
			return 1;
		else
		if(itd.hasNext())
			return -1;
		else
			return 0;
	}

}
