/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.concurrent.data;

import java.util.Comparator;

import logic.data.Term;

public class TermComparator implements Comparator<Term> {

	public int compare(Term arg0, Term arg1) {
		int[] k0 = arg0.getKey();
		int[] k1 = arg1.getKey();
		int n = k0.length;
		int n1 = k1.length;
		if (n < n1)
			return -1;
		if (n > n1)
			return 1;
		for (int i = 0; i < n; i++) {
			if (k0[i] < k1[i])
				return -1;
			if (k0[i] > k1[i])
				return 1;
		}

		return 0;
	}

}