/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.concurrent.function;

import jfp.datatype.Pair;
import java.util.*;

import concurrent.AbstractAnalyzerTaskFactory;
import concurrent.SearchFailureException;
import concurrent.Task;
import concurrent.Task.TaskInstance;

public class FunctionSetProcedure<T1, T2>
		extends
		AbstractAnalyzerTaskFactory<Pair<List<T1>, List<T2>>, Pair<List<T1>, List<T2>>> {

	@Override
	public Task<Pair<List<T1>, List<T2>>, Pair<List<T1>, List<T2>>> create() {
		return new FunctionSetProcedureTask<T1, T2>();
	}

	public class FunctionSetProcedureTask<T1, T2> implements
			Task<Pair<List<T1>, List<T2>>, Pair<List<T1>, List<T2>>> {
		boolean hasNext;

		List<T1> s1;

		List<T2> s2;

		List<T1> dom;

		Iterator<T2>[] it2;

		List<T2> range = new ArrayList<T2>();

		int n;

		public boolean hasNext() {
			return hasNext;
		}

		public boolean input(Pair<List<T1>, List<T2>> input) {
			s1 = input.fst();
			s2 = input.snd();
			n = s1.size();
			if (s2.size() == 0 && n != 0) {
				hasNext = false;
			} else {
				hasNext = true;
			}
			it2 = new Iterator[n];
			for (int i = 0; i < n; i++) {
				it2[i] = s2.iterator();
				T2 e2 = it2[i].next();
				range.add(e2);
			}
			dom = new ArrayList<T1>(s1);
			return false;
		}

		public concurrent.Task.TaskInstance<Pair<List<T1>, List<T2>>> next() {
			final ArrayList<T1> al1 = new ArrayList<T1>(dom);
			final ArrayList<T2> al2 = new ArrayList<T2>(range);
			if (n == 0) {
				hasNext = false;

			} else if (it2[n - 1].hasNext()) {
				range.set(n - 1, it2[n - 1].next());
			} else {
				int p = n - 1;
				do {
					p--;
				} while (p >= 0 && !it2[p].hasNext());
				if (p >= 0) {
					range.set(p, it2[p].next());
					for (int i = p + 1; i < n; i++) {
						it2[i] = s2.iterator();
						range.set(i, it2[i].next());
					}
				} else {
					hasNext = false;
				}
			}

			return new Task.TaskInstance<Pair<List<T1>, List<T2>>>() {

				public Pair<List<T1>, List<T2>> run()
						throws SearchFailureException {
					return new Pair<List<T1>, List<T2>>(al1, al2);
				}

			};
		}
	}

}
