/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.concurrent.function;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import concurrent.AbstractAnalyzerTaskFactory;
import concurrent.SearchFailureException;
import concurrent.Task;

import jfp.datatype.Pair;

public class SetParitionProcedure<E> extends
		AbstractAnalyzerTaskFactory<Set<E>, Pair<List<E>, List<E>>> {

	@Override
	public Task<Set<E>, Pair<List<E>, List<E>>> create() {
		return new Task<Set<E>, Pair<List<E>, List<E>>>() {

			BigInteger i;

			BigInteger one = new BigInteger("1");

			boolean hasNext;

			int n;

			List<E> in;

			public boolean hasNext() {
				return hasNext;
			}

			public boolean input(Set<E> input) {
				in = new ArrayList<E>(input);
				n = in.size();
				hasNext = true;
				i = new BigInteger("0");
				return false;
			}

			public concurrent.Task.TaskInstance<Pair<List<E>, List<E>>> next() {
				final List<E> s1 = new ArrayList<E>();
				final List<E> s2 = new ArrayList<E>();

				for (int k = 0; k < n; k++) {
					if (i.testBit(k)) {
						s1.add(in.get(k));
					} else {
						s2.add(in.get(k));
					}
				}
				i = i.add(one);
				if (i.testBit(n))
					hasNext = false;
				return new Task.TaskInstance<Pair<List<E>, List<E>>>() {

					public Pair<List<E>, List<E>> run()
							throws SearchFailureException {
						return new Pair<List<E>, List<E>>(s1, s2);
					}

				};
			}
		};

	}

}
