/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.data;

import java.util.*;

public class Term extends Tree<Symbol> {

    int[] key;

    public Term(Symbol val, Tree<Symbol>[] subtrees) {
        super(val, subtrees);
    }

    public static final int[] getKey(Term t) {
        if (t.key != null) {
            return t.key;
        }
        int[][] keys = new int[t.subtrees.length][];
        int size = 1;

        for (int i = 0; i < t.subtrees.length; i++) {
            keys[i] = getKey((Term) t.subtrees[i]);
            size += keys[i].length;
        }

        int[] akey = new int[size];

        int k = 0;
        akey[k++] = t.val.id;
        for (int i = 0; i < t.subtrees.length; i++) {
            System.arraycopy(keys[i], 0, akey, k, keys[i].length);
            k += keys[i].length;
        }

        t.key = akey;

        return akey;

    }

    public int[] getKey() {
        return getKey(this);
    }

    public int size() {
        return getKey().length;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (!(obj instanceof Term)) {
            return false;
        }
        final Term other = (Term) obj;
        if (!Arrays.equals(this.getKey(), other.getKey())) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 41 * hash + Arrays.hashCode(this.getKey());
        return hash;
    }
}
