#!/usr/bin/perl -w

use strict;

# global constants
my $dracula = 'dracula';
my $vampire = 'vampire';

my $exe = $ENV{'_'};
my ($dir) = $exe =~ m/\A(.*)\/drakosha\.pl/;
if (! defined $dir) {
  $dir = '.';
}

my $SPIDER = 0;

if (@ARGV < 2) {
  die "Usage: drakosha time_limit file_name <include_dir>\n";
}

my $timeLimit = $ARGV[0];
my $inputFile = $ARGV[1];

my $incDir = $ARGV[2] || $ENV{'TPTP'};
if ($ENV{'TPTP'}) {
  $ENV{'TPTP_DIR'} = "$ENV{'TPTP'}/";
}
my $include = $incDir ? "--include $incDir/" : '';

# end of the time for running
my $start = time();
my $end = $start + $timeLimit;

sub drakoshaMustWin {
  my $props = `$dir/$dracula --time_limit $timeLimit --mode profile $include $inputFile`;
  my ($cat,$prop,$atoms) = $props =~ m/\A(\S+)\s+(\d+)\s+(\d+)\s*\Z/;
  if ($cat eq 'PEQ') {
    runStrategy(qw(lrs-11_4:3_bas=on_ep=exp1_fde=none_600 465 lrs-11_16_bas=on_bd=preordered_bs=off_ep=exp1_nwc=1.3_600 289 lrs+1011_6_bd=off_bs=off_ep=exp1_fsr=off_nwc=2.3_600 20 lrs-1012_32_bs=off_ep=exp1_nwc=4.0_600 45 dis+8_7_bas=on_bd=preordered_bs=off_ep=exp1_nwc=2.2_sos=on_600 46 dis+1011_25_bas=on_ep=exp1_fde=none_nwc=1.1_stl=60_600 271 lrs+8_7_bas=on_bs=off_fde=none_nwc=1.7_600 146 lrs-1012_68_bs=off_fde=none_nwc=1.4_2400 2228)); # (total time: 3590)
    return;
  }
  if ($cat eq 'HEQ') {
    runStrategy(qw(dis+16_6_nwc=5.0_600 103 lrs-1012_3_bs=off_fde=none_lcm=predicate_nwc=2.1_600 156 lrs+17_2:1_bas=on_bs=off_lcm=kinky_600 7 lrs-11_8_bd=off_bs=off_ep=on_nwc=2.0_600 8 lrs-1012_2_bas=on_bd=off_bs=off_lcm=kinky_sos=on_600 11 lrs+1010_4_bd=preordered_bs=off_lcm=kinky_nwc=3.0_600 1 dis+10_2:3_nwc=2.5_600 14 lrs+1012_2:3_bd=off_ep=on_nwc=1.6_600 153 dis+13_11_bs=off_nwc=9.0_600 252 ott+16_45_ep=exp1_nwc=1.1_600 187 dis+1011_2:1_bs=off_ep=on_nwc=5.0_600 287 lrs+16_24_bs=off_ep=on_fde=none_nwc=1.8_600 277 dis+16_26_bd=preordered_bs=off_fde=none_nwc=3.6_wi=on_1200 358 lrs-1012_68_bs=off_fde=none_nwc=1.4_2400 1157)); # (total time: 3111)
    return;
  }
  if ($cat eq 'HNE') {
    runStrategy(qw(lrs+10_2:3_bs=off_fde=none_nwc=2.8_600 101 lrs+11_500_bas=on_bs=off_ep=on_900 475 lrs-1012_2_bs=off_ep=on_nwc=1.8_900 160 lrs+10_200_bas=on_ep=on_fde=none_nwc=3.3_wi=on_600 3 lrs-11_256_bs=off_ep=on_nwc=4.0_600 6 dis+1010_5:1_bs=off_lcm=predicate_nwc=4.5_sp=on_600 40 dis+10_13_ep=exp1_nwc=3.3_wi=on_600 458 lrs+1012_5:1_bd=off_bs=off_sos=on_600 70)); # (total time: 1393)
    return;
  }
  if ($cat eq 'NNE') {
    runStrategy(qw(lrs+13_3:1_bs=off_ep=on_nwc=2.9_sos=on_600 589 dis+1011_12_bs=off_sos=on_600 202 lrs+16_5:4_bs=off_nwc=4.0_600 87 lrs+11_500_bas=on_bs=off_ep=on_900 0 lrs+8_14_ep=exp1_fde=none_nwc=5.2_wi=on_600 195 dis+17_8_bas=on_bs=off_ep=on_sos=on_600 185 dis+1012_5_bas=on_bs=off_ep=on_fde=none_lcm=kinky_sos=on_1200 457 lrs+17_13_bs=off_ep=on_nwc=2.4_sos=on_600 218 dis+10_15_bas=on_bs=off_ep=on_600 226 lrs+17_2_bs=off_ep=on_nwc=2.6_1200 575 lrs+1011_3:2_ep=on_lcm=kinky_sos=on_900 865)); # (total time: 3709)
    return;
  }
  if ($cat eq 'NEQ') {
    if ($prop == 3) {
    runStrategy(qw(lrs+1011_2:1_bs=off_lcm=kinky_sos=on_600 485 lrs+1010_1_lcm=predicate_600 197 lrs+10_2:1_bas=on_sos=on_sp=on_600 551 lrs+1012_10_bas=on_bs=off_ep=exp1_fde=none_nwc=3.5_600 5 dis+1013_32_nwc=1.5_600 19 lrs-1012_11_bs=off_nwc=4.0_600 9 lrs-1012_2_bas=on_bd=off_bs=off_lcm=kinky_sos=on_600 157 dis+11_256_bd=off_bs=off_fde=none_sos=on_600 66 lrs+1011_3:1_bas=on_bs=off_nwc=3.9_600 39 dis+16_3:1_bs=off_ep=on_nwc=3.9_wi=on_600 193 lrs+17_4:3_bas=on_bs=off_ep=on_nwc=2.3_600 92 lrs+1011_3_bs=off_600 169 lrs+1011_5:1_bd=off_bs=off_ep=on_fde=none_lcm=predicate_sos=on_600 477 dis+13_43_bas=on_bd=off_ep=on_nwc=4.8_1800 1672 lrs+11_1_bas=on_bd=off_bs=off_ep=on_lcm=predicate_nwc=1.7_600 219 lrs+1012_5:1_bd=off_bs=off_sos=on_600 369 lrs+1011_5:1_bs=off_ep=on_sos=on_600 381)); # (total time: 5270)
      return;
    }
    runStrategy(qw(lrs+17_4_bas=on_bs=off_fde=none_nwc=2.7_600 441 lrs+1011_2:1_bs=off_lcm=kinky_sos=on_600 254 lrs+1011_5:4_bas=on_bs=off_ep=on_lcm=kinky_nwc=3.8_600 300 lrs-1012_22_bas=on_bs=off_ep=on_fde=none_nwc=3.9_600 3 dis+16_2_bas=on_bs=off_ep=exp1_fde=none_nwc=3.7_600 24 lrs+16_24_bs=off_ep=on_fde=none_nwc=1.8_600 31 dis+1011_36_bs=off_ep=on_lcm=predicate_nwc=4.0_600 93 dis+16_13_bas=on_ep=exp1_fsr=off_nwc=3.6_600 6 lrs-1012_32_bs=off_ep=exp1_nwc=4.0_600 1 dis-1012_5:1_bas=on_ep=exp1_fde=none_nwc=2.9_600 5 lrs+1011_5:1_bd=off_bs=off_ep=on_fde=none_lcm=predicate_sos=on_600 85 lrs+1012_5:1_bd=off_bs=off_sos=on_600 41 lrs+10_2:3_bs=off_fde=none_nwc=2.8_600 88 lrs+16_6_bas=on_bs=off_nwc=2.0_600 82 dis-1012_2_bas=on_bs=off_ep=on_fde=none_lcm=predicate_nwc=3.8_600 87 dis+11_4_lcm=predicate_600 87 lrs+1013_6:1_ep=on_fde=none_nwc=2.0_600 31 lrs+8_24_bd=off_bs=off_fsr=off_lcm=predicate_nwc=4.2_600 93 lrs+16_5:4_bs=off_nwc=4.0_600 203 lrs+10_2:1_bas=on_sos=on_sp=on_600 255 lrs+1011_20_bas=on_bs=off_ep=exp1_fde=none_nwc=3.2_600 332 lrs+1012_10_bas=on_bs=off_ep=exp1_fde=none_nwc=3.5_600 488 lrs+10_4_lcm=kinky_nwc=3.0_600 297 lrs-11_4_bs=off_ep=on_lcm=kinky_nwc=1.8_600 346 lrs+1011_3:1_bas=on_bs=off_nwc=3.9_600 527)); # (total time: 4450)
    return;
  }
  if ($cat eq 'FNE') {
    runStrategy(qw(lrs+10_4:3_bas=on_bs=off_ep=on_nwc=1.3_600 154 lrs+8_14_bas=on_bd=preordered_bs=off_lcm=kinky_sp=on_wi=on_600 262 lrs+13_8_bs=off_ep=exp1_nwc=2.5_sp=on_600 13 lrs+13_4:1_bas=on_bs=off_ep=exp1_nwc=1.5_600 375)); # (total time: 844)
    return;
  }
  if ($cat eq 'FEQ') {
    if ($prop == 1) {
    runStrategy(qw(lrs+10_10:1_bs=off_fde=none_lcm=predicate_nwc=1.5_600 552 lrs+10_4:3_bas=on_bs=off_ep=on_nwc=1.3_600 853 lrs+1012_60_bas=on_bd=off_bs=off_fde=none_600 65 lrs+17_10:1_bd=off_bs=off_ep=exp1_nwc=1.4_600 366 lrs+1011_44_bas=on_bd=off_bs=off_fde=none_lcm=kinky_nwc=1.3_600 470 lrs+17_2:1_bas=on_bs=off_ep=exp1_lcm=kinky_nwc=1.5_600 120 lrs+17_8:1_bas=on_bd=preordered_bs=off_ep=exp1_fde=none_fsr=off_lcm=predicate_nwc=1.1_sos=on_sp=on_600 0 dis+11_19_bas=on_bd=off_ep=exp1_lcm=predicate_nwc=2.3_900 130 lrs+16_2:3_ep=exp1_fde=none_lcm=predicate_nwc=1.9_600 10 lrs+11_64_bas=on_bs=off_ep=exp1_nwc=3.1_wi=on_600 18 lrs+16_4:1_bas=on_bs=off_ep=exp1_lcm=kinky_nwc=1.2_600 8 dis+1012_128_lcm=predicate_nwc=3.3_600 50 lrs+11_6_bs=off_ep=exp1_fde=none_lcm=predicate_nwc=1.2_600 104 lrs+1013_10_ep=exp1_fde=none_nwc=1.6_600 66 dis+10_41_bas=on_bs=off_ep=RS_lcm=predicate_nwc=2.4_sp=on_600 397 lrs+1010_4_bd=preordered_bs=off_lcm=kinky_nwc=3.0_600 248 lrs+16_2_bd=off_ep=exp1_fde=none_nwc=2.6_600 86 lrs+13_10:1_bas=on_bs=off_ep=exp1_lcm=predicate_nwc=1.1_600 185 lrs+1010_4:1_bs=off_lcm=predicate_nwc=1.1_600 483 lrs+16_27_bas=on_bd=off_bs=off_ep=exp1_nwc=1.2_600 809 lrs+1011_1_nwc=1.5_600 312 lrs+1013_4_bas=on_bs=off_ep=R_fde=none_lcm=predicate_nwc=1.7_600 339)); # (total time: 5891)
      return;
    }
    if ($prop == 0) {
    runStrategy(qw(lrs+13_3:1_bas=on_ep=exp1_600 446 dis+1013_32_nwc=1.5_600 145 lrs+17_2:1_bas=on_bs=off_ep=exp1_lcm=kinky_nwc=1.5_600 144 lrs+16_27_bas=on_bd=off_bs=off_ep=exp1_nwc=1.2_600 455 lrs+1010_4:1_bs=off_lcm=predicate_nwc=1.1_600 283 lrs-11_4_bs=off_ep=on_lcm=kinky_nwc=1.8_600 6 lrs-1012_2_ep=R_600 21 lrs+16_4:1_bas=on_bs=off_ep=exp1_lcm=kinky_nwc=1.2_600 1 lrs+10_2:1_bas=on_sos=on_sp=on_600 4 lrs+11_0_bas=on_bd=off_bs=off_ep=exp1_fde=none_lcm=kinky_nwc=2.3_600 33 lrs+10_2:1_bs=off_ep=exp1_fde=none_lcm=predicate_nwc=1.8_600 213 dis+1013_6_ep=exp1_fde=none_nwc=1.1_wi=on_600 100 dis+10_29_ep=on_fde=none_wi=on_600 403 dis+1012_128_lcm=predicate_nwc=3.3_600 100 lrs+10_10:1_bs=off_fde=none_lcm=predicate_nwc=1.5_600 95 dis+1010_8_bas=on_bs=off_ep=exp1_lcm=kinky_900 264 lrs+1013_10_ep=exp1_fde=none_nwc=1.6_600 189 lrs+13_4:1_bas=on_bs=off_ep=exp1_nwc=1.5_600 126 dis+1010_3:2_bd=off_ep=exp1_fde=none_lcm=predicate_nwc=4.0_900 155 lrs+1013_50_bd=off_ep=exp1_fde=none_600 179 lrs+1013_10_bd=preordered_ep=exp1_fde=none_nwc=1.5_wi=on_600 183 dis-11_34_bd=off_bs=off_ep=exp1_fsr=off_nwc=1.2_wi=on_900 246 dis+11_19_bas=on_bd=off_ep=exp1_lcm=predicate_nwc=2.3_900 919)); # (total time: 4940)
      return;
    }
    if ($prop == 15) {
    runStrategy(qw(lrs+16_3:1_bas=on_bd=off_bs=off_fde=none_lcm=kinky_nwc=1.6_sp=on_600 600 lrs-1012_2_ep=R_600 293 lrs+13_3:1_bas=on_ep=exp1_600 242 lrs+17_2:1_bas=on_bs=off_lcm=kinky_600 127 lrs+17_3:2_bs=off_lcm=kinky_nwc=2.2_sp=on_600 574 lrs+16_7:1_bd=off_bs=off_ep=exp1_nwc=2.0_600 87 lrs+1013_10_ep=exp1_fde=none_nwc=1.6_600 91 lrs+1012_5:4_bas=on_bs=off_ep=on_fde=none_600 125 lrs+1010_4:1_bs=off_lcm=predicate_nwc=1.1_600 95 lrs+17_0_bas=on_ep=on_fde=none_lcm=predicate_nwc=2.0_600 112 lrs+11_6_bs=off_ep=exp1_fde=none_lcm=predicate_nwc=1.2_600 136 lrs+1011_2:1_bas=on_bd=off_bs=off_ep=RS_lcm=predicate_nwc=4.5_600 406 lrs+16_6:1_bas=on_bd=off_bs=off_ep=RS_lcm=predicate_nwc=1.4_600 212 lrs+16_2:3_ep=exp1_fde=none_lcm=predicate_nwc=1.9_600 281 lrs-11_2:3_bd=off_bs=off_fde=none_lcm=predicate_600 558)); # (total time: 4089)
      return;
    }
    # any other property for FEQ
    runStrategy(qw(lrs+10_4:3_bas=on_bs=off_ep=on_nwc=1.3_600 305 lrs+1011_2:1_bas=on_bd=off_bs=off_ep=RS_lcm=predicate_nwc=4.5_600 129 lrs+10_2:1_bs=off_ep=exp1_fde=none_lcm=predicate_nwc=1.8_600 373 lrs+1011_1_nwc=1.5_600 316 lrs+16_4:1_bas=on_bs=off_ep=exp1_lcm=kinky_nwc=1.2_600 357 lrs+16_7:1_bd=off_bs=off_ep=exp1_nwc=2.0_600 113 dis+1013_32_nwc=1.5_600 43 lrs+1011_5:1_bd=off_bs=off_ep=on_fde=none_lcm=predicate_sos=on_600 1 lrs+10_60_bas=on_ep=exp1_fde=none_fsr=off_lcm=kinky_nwc=1.8_sp=on_600 1 lrs+11_3_bs=off_ep=exp1_fde=none_nwc=1.1_wi=on_600 2 dis+1010_112_bas=on_bd=off_ep=exp1_fde=none_nwc=3.1_1200 0 lrs+13_3:1_bas=on_ep=exp1_600 3 lrs-1012_5:1_sos=on_sp=on_600 13 lrs+1010_4:1_bs=off_lcm=predicate_nwc=1.1_600 83 lrs+13_8:1_bas=on_bd=off_bs=off_ep=RS_nwc=5.4_sos=on_sp=on_600 308 lrs+1013_11_bas=on_ep=on_lcm=kinky_nwc=1.2_600 79 lrs+1012_5:4_bas=on_bs=off_ep=on_fde=none_600 95 lrs+8_6_fde=none_nwc=1.5_600 135 lrs+11_0_bas=on_bd=off_bs=off_ep=exp1_fde=none_lcm=kinky_nwc=2.3_600 100 lrs+10_10:1_bs=off_fde=none_lcm=predicate_nwc=1.5_600 55 lrs+13_10:1_bas=on_bs=off_ep=exp1_lcm=predicate_nwc=1.1_600 232 dis+10_3:1_bas=on_bd=off_bs=off_lcm=predicate_nwc=1.1_600 85 lrs-1012_4_ep=on_nwc=5.0_600 94 lrs+17_2:1_bas=on_bs=off_ep=exp1_lcm=kinky_nwc=1.5_600 136 lrs-1012_2_ep=R_600 445 lrs-11_2:3_bd=off_bs=off_fde=none_lcm=predicate_600 199 dis+1010_3:2_bd=off_ep=exp1_fde=none_lcm=predicate_nwc=4.0_900 489 dis+10_29_ep=on_fde=none_wi=on_600 239 lrs+17_10:1_bd=off_bs=off_ep=exp1_nwc=1.4_600 245)); # (total time: 4965)
    return;
  }
  if ($cat eq 'UEQ') {
    runStrategy(qw(lrs+8_8_bd=preordered_bs=off_fde=none_nwc=2.5_1200 136 lrs+8_86_bas=on_bs=off_wi=on_1200 636 lrs+8_2:3_600 16 lrs+8_0_bd=preordered_bs=off_nwc=4.3_1200 66 lrs+8_8:1_bas=on_bd=preordered_bs=off_nwc=1.3_3000 796 lrs+8_0_bas=on_nwc=4.5_wi=on_1200 241 dis+8_2_bas=on_fde=none_nwc=3.3_wi=on_4800 2920 dis+8_15_bas=on_bs=off_nwc=1.4_wi=on_2100 810 lrs+8_10:1_bs=off_nwc=1.9_1200 331 lrs+8_13_fde=none_nwc=1.1_1200 923)); # (total time: 6975)
    return;
  }
}

sub runStrategy {
  while (@_) {
    my $strat = shift;
    my $timeSlice = shift;
    my $time = time();
    if ($time >= $end) {
      failed();
      return;
    }
    my ($stl) = $strat =~ m/_(\d+)\Z/;
    $stl = $stl/10;
    if ($time + $timeSlice/10 > $end) {
      $timeSlice = ($end-$time)*10;
      $stl = '';
    }
    else {
      $stl = "-stl $stl";
      my $extra = int ($timeSlice/60);
      if ($extra < 10) {
	$extra = 10;
      }
      $timeSlice += 10;
    }

    my $sliceLimit = $timeSlice/10;
    if (! $SPIDER) {
      print "% Running slice $strat for $timeSlice deciseconds...\n";
    }
    my $mode = $SPIDER ? 'spider' : 'vampire';
    my $command = "$dir/vampire --decode $strat --normalize on --time_limit $sliceLimit $stl --mode $mode $include $inputFile";
#    print "$command\n";
    my $runResult = `$command`;
    if ($SPIDER) {
      if ($runResult =~ m/\A\+\s/s) {
	my $total = time() - $start;
	print "+ $inputFile $total casc\n";
	return;
      }
    }
    elsif ($runResult =~ m/Refutation found/s) {
      my $total = time() - $start;
      print "%%%%% $runResult",
            "%%%%% Total time: $total\n";
      return;
    }
  }
  # not proved
  failed();
}

sub failed {
  my $total = time() - $start;
  if ($SPIDER) {
    print "- $inputFile $total casc\n";
  }
  else {
    print "%%%%% I hate to say that I cannot prove this problem.
%%%%% Why? Well, Geoff set the time limit to prevent me
%%%%% from proving it!
%%%%% SZS status Unknown %%%%%
%%%%% Total time: $total\n";
  }
}

drakoshaMustWin();

# When terminating an attempt to solve a problem, the systems have
# to output a distinguished string (specified by the entrant),
# indicating what solution has been found or that no conclusion has been
# reached. The distinguished strings the problem status should use the 
# SZS ontology, in a line starting SZS status. For example
#
#   SZS status Theorem for SYN075+1
#
# or
#   SZS status GaveUp for SYN075+1
#
# Regardless of whether the SZS status values are used,
# the distinguished strings must be different for:
#
#  * Proved theorems of FOF problems (SZS status Theorem)
#  * Disproved conjectures of FNT problems (SZS status CounterSatisfiable)
#  * Unsatisfiable sets of formulae (FOF problems without conjectures)
#   and unsatisfiable set of clauses (CNF problems) (SZS status Unsatisfiable)
#  * Satisfiable sets of formulae (FNT problems without conjectures)
#    and satisfiable set of clauses (SAT problems) (SZS status Satisfiable)
#
# The first distinguished string output is accepted as the system's claimed
# result.
# When outputing proofs/models for the proof/model ranking classes, the start
# and end of the proof/model must be delimited by distinguished strings
# (specified by the entrant). The distinguished strings should specify the
# precise output form named in the SZS ontology, using lines starting SZS
# output start and SZS output end. For example
#
# SZS output start CNFRefutation for SYN075+1
#
# ... SZS output
#
# end CNFRefutation for SYN075+1
# Regardless of whether the SZS output forms are used,
# the distinguished strings must be different for:
#
# * Proofs (SZS output forms Proof, Refutation, CNFRefutation)
# * Models (SZS output forms Model, FiniteModel, InfiniteModel, Saturation)
#
# The string specifying the problem status must be output before the
# start of a proof/model.
