(*----------------------------------------------------------------------(C)-*)
(* Copyright (C) 2006-2008 K. Korovin and The University of Manchetser. 
   This file is part of iProver - a theorem prover for first-order logic.

   iProver is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   iProver is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
   See the GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with iProver.  If not, see <http://www.gnu.org/licenses/>.         *)
(*----------------------------------------------------------------------[C]-*)

type subst       = Subst.subst
type bsubst      = SubstBound.bound_subst
type term_db_ref = TermDB.termDB ref
type bound       = int
type constr 
type constr_list

(* creates the dismatching constr. from bsubst restricted to bound *)
val create_constr      : term_db_ref -> bound -> bsubst -> constr
val create_constr_norm : subst -> constr 
val create_constr_list : unit -> constr_list

val add_constr         : constr_list -> constr -> constr_list

(* true if bsubst restricted to bound satisfies the constr. *)
val check_constr       : bound -> bsubst -> constr -> bool
val check_constr_list  : bound -> bsubst -> constr_list -> bool

val check_constr_norm      : subst -> constr -> bool
val check_constr_norm_list : subst -> constr_list -> bool

(* feature index version of constraints *)
type constr_list_feature
val create_constr_feature_list : unit -> constr_list_feature
val add_constr_feature_list    : 
    constr_list_feature-> constr -> unit (*-> constr_list_feature *)

val check_constr_feature_list  : subst -> constr_list_feature -> bool

(* to string *)
val to_string              : constr -> string
val constr_list_to_string  : constr_list -> string
