(*----------------------------------------------------------------------(C)-*)
(* Copyright (C) 2006-2008 K. Korovin and The University of Manchetser. 
   This file is part of iProver - a theorem prover for first-order logic.

   iProver is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   iProver is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
   See the GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with iProver.  If not, see <http://www.gnu.org/licenses/>.         *)
(*----------------------------------------------------------------------[C]-*)

type token =
  | Comma
  | Dot
  | Semicolumn
  | LeftParen
  | RightParen
  | LBrace
  | RBrace
  | True
  | False
  | ForAll
  | Exists
  | And
  | NegAnd
  | Or
  | NegOr
  | Equality
  | NegEquality
  | Negation
  | ImplicationLR
  | ImplicationRL
  | Equivalence
  | NegEquivalence
  | Plus
  | Minus
  | CNF of (string)
  | FOF of (string)
  | Include of (string)
  | Axiom of (string)
  | Hypothesis of (string)
  | Conjecture of (string)
  | Negated_conjecture of (string)
  | Lemma of (string)
  | Theorem of (string)
  | Plain of (string)
  | Unknown of (string)
  | Derived of (string)
  | Equal of (string)
  | Inference of (string)
  | Theory of (string)
  | AC of (string)
  | File of (string)
  | Creator of (string)
  | Description of (string)
  | Iquote of (string)
  | Status of (string)
  | Thm of (string)
  | Sat of (string)
  | Refutation of (string)
  | PositiveInteger of (string)
  | FormulaItem of (string)
  | InferenceItem of (string)
  | GeneralFunction of (string)
  | InferenceInfo of (string)
  | DagSource of (string)
  | ExternalSource of (string)
  | UpperWord of (string)
  | LowerWord of (string)
  | String of (string)
  | QuotedStr of (string)
  | CommentPercent of (string)
  | CommentEprover of (string)
  | CommentStar of (string)
  | AnnotationPercent of (string)
  | AnnotationStar of (string)
  | EOF

open Parsing;;
# 1 "src/parser_tptp.mly"
 open Parser_types

 let foo = "foo" 
 let disquote_string  str = 
      String.sub str 1 ((String.length str)-2)
 let parse_error s = raise Parser_types.Parsing_fails
# 77 "src/parser_tptp.ml"
let yytransl_const = [|
  257 (* Comma *);
  258 (* Dot *);
  259 (* Semicolumn *);
  260 (* LeftParen *);
  261 (* RightParen *);
  262 (* LBrace *);
  263 (* RBrace *);
  264 (* True *);
  265 (* False *);
  266 (* ForAll *);
  267 (* Exists *);
  268 (* And *);
  269 (* NegAnd *);
  270 (* Or *);
  271 (* NegOr *);
  272 (* Equality *);
  273 (* NegEquality *);
  274 (* Negation *);
  275 (* ImplicationLR *);
  276 (* ImplicationRL *);
  277 (* Equivalence *);
  278 (* NegEquivalence *);
  279 (* Plus *);
  280 (* Minus *);
    0 (* EOF *);
    0|]

let yytransl_block = [|
  281 (* CNF *);
  282 (* FOF *);
  283 (* Include *);
  284 (* Axiom *);
  285 (* Hypothesis *);
  286 (* Conjecture *);
  287 (* Negated_conjecture *);
  288 (* Lemma *);
  289 (* Theorem *);
  290 (* Plain *);
  291 (* Unknown *);
  292 (* Derived *);
  293 (* Equal *);
  294 (* Inference *);
  295 (* Theory *);
  296 (* AC *);
  297 (* File *);
  298 (* Creator *);
  299 (* Description *);
  300 (* Iquote *);
  301 (* Status *);
  302 (* Thm *);
  303 (* Sat *);
  304 (* Refutation *);
  305 (* PositiveInteger *);
  306 (* FormulaItem *);
  307 (* InferenceItem *);
  308 (* GeneralFunction *);
  309 (* InferenceInfo *);
  310 (* DagSource *);
  311 (* ExternalSource *);
  312 (* UpperWord *);
  313 (* LowerWord *);
  314 (* String *);
  315 (* QuotedStr *);
  316 (* CommentPercent *);
  317 (* CommentEprover *);
  318 (* CommentStar *);
  319 (* AnnotationPercent *);
  320 (* AnnotationStar *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\002\000\002\000\002\000\002\000\003\000\003\000\
\011\000\011\000\007\000\007\000\009\000\009\000\009\000\014\000\
\014\000\014\000\014\000\014\000\014\000\014\000\014\000\015\000\
\010\000\010\000\016\000\016\000\018\000\018\000\018\000\021\000\
\020\000\023\000\023\000\024\000\024\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\017\000\019\000\026\000\022\000\
\027\000\027\000\027\000\030\000\030\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\028\000\029\000\029\000\
\032\000\032\000\025\000\031\000\031\000\034\000\008\000\008\000\
\033\000\035\000\035\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\004\000\004\000\038\000\038\000\037\000\005\000\005\000\
\005\000\006\000\006\000\012\000\012\000\012\000\039\000\039\000\
\041\000\042\000\043\000\043\000\044\000\044\000\045\000\046\000\
\047\000\047\000\040\000\040\000\040\000\048\000\050\000\049\000\
\051\000\013\000\013\000\052\000\052\000\053\000\053\000\053\000\
\054\000\054\000\057\000\058\000\055\000\055\000\059\000\059\000\
\061\000\062\000\060\000\064\000\064\000\063\000\063\000\056\000\
\056\000\065\000\065\000\066\000\000\000"

let yylen = "\002\000\
\002\000\001\000\001\000\001\000\001\000\001\000\009\000\010\000\
\002\000\004\000\001\000\001\000\003\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\003\000\
\006\000\001\000\001\000\001\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\003\000\003\000\003\000\006\000\
\001\000\001\000\001\000\003\000\003\000\002\000\001\000\004\000\
\001\000\001\000\001\000\001\000\002\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\005\000\006\000\001\000\002\000\001\000\001\000\001\000\
\001\000\001\000\001\000\004\000\004\000\001\000\001\000\001\000\
\010\000\001\000\001\000\003\000\001\000\002\000\002\000\004\000\
\001\000\001\000\001\000\001\000\001\000\006\000\001\000\006\000\
\001\000\002\000\003\000\001\000\003\000\004\000\004\000\004\000\
\001\000\001\000\004\000\004\000\001\000\001\000\004\000\004\000\
\001\000\006\000\004\000\001\000\001\000\002\000\003\000\001\000\
\004\000\001\000\002\000\001\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\011\000\012\000\000\000\111\000\113\000\112\000\
\114\000\115\000\002\000\165\000\000\000\003\000\004\000\005\000\
\006\000\000\000\000\000\001\000\000\000\073\000\110\000\000\000\
\076\000\077\000\078\000\079\000\080\000\081\000\082\000\083\000\
\084\000\085\000\086\000\087\000\088\000\089\000\090\000\091\000\
\092\000\093\000\094\000\095\000\096\000\097\000\098\000\099\000\
\100\000\101\000\102\000\103\000\104\000\105\000\074\000\000\000\
\072\000\071\000\075\000\000\000\000\000\000\000\000\000\106\000\
\109\000\000\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\000\000\000\000\015\000\107\000\000\000\
\000\000\000\000\057\000\058\000\035\000\034\000\000\000\047\000\
\000\000\000\000\067\000\000\000\000\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\000\000\051\000\000\000\000\000\
\049\000\050\000\059\000\063\000\000\000\013\000\000\000\000\000\
\062\000\000\000\069\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\046\000\000\000\000\000\000\000\000\000\032\000\000\000\070\000\
\000\000\000\000\118\000\000\000\000\000\000\000\007\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\064\000\000\000\000\000\000\000\008\000\000\000\000\000\000\000\
\053\000\000\000\119\000\000\000\120\000\000\000\000\000\000\000\
\000\000\133\000\131\000\132\000\000\000\010\000\000\000\037\000\
\056\000\000\000\116\000\000\000\000\000\000\000\117\000\138\000\
\000\000\000\000\000\000\000\000\000\000\033\000\122\000\000\000\
\129\000\130\000\000\000\000\000\137\000\000\000\000\000\000\000\
\000\000\139\000\000\000\000\000\128\000\000\000\000\000\000\000\
\000\000\000\000\145\000\146\000\000\000\000\000\000\000\000\000\
\149\000\150\000\000\000\160\000\000\000\000\000\141\000\000\000\
\135\000\000\000\000\000\000\000\000\000\142\000\000\000\000\000\
\000\000\143\000\144\000\000\000\000\000\134\000\136\000\000\000\
\000\000\153\000\000\000\000\000\000\000\000\000\000\000\156\000\
\157\000\000\000\000\000\000\000\147\000\148\000\151\000\155\000\
\000\000\152\000\158\000\000\000\163\000\161\000\000\000\000\000\
\000\000\065\000\000\000\159\000\000\000\126\000\000\000\000\000\
\000\000\127\000\121\000\124\000\000\000\154\000"

let yydgoto = "\002\000\
\012\000\013\000\014\000\015\000\016\000\017\000\018\000\092\000\
\076\000\093\000\127\000\015\001\182\000\077\000\078\000\094\000\
\095\000\096\000\097\000\098\000\099\000\100\000\101\000\153\000\
\102\000\103\000\104\000\105\000\106\000\138\000\107\000\108\000\
\109\000\115\000\058\000\059\000\024\000\062\000\172\000\177\000\
\173\000\200\000\016\001\017\001\022\001\178\000\203\000\179\000\
\180\000\234\000\206\000\196\000\197\000\218\000\224\000\000\001\
\219\000\220\000\225\000\226\000\251\000\254\000\001\001\002\001\
\003\001\230\000"

let yysindex = "\009\000\
\001\000\000\000\000\000\000\000\021\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\
\000\000\032\255\003\255\000\000\070\001\000\000\000\000\142\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\053\255\
\000\000\000\000\000\000\091\255\070\001\119\255\130\000\000\000\
\000\000\129\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\140\255\128\255\000\000\000\000\042\000\
\130\255\042\000\000\000\000\000\000\000\000\000\165\255\000\000\
\035\001\176\255\000\000\184\255\251\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\186\255\000\000\042\000\029\255\
\000\000\000\000\000\000\000\000\000\000\000\000\095\000\035\001\
\000\000\145\255\000\000\035\001\239\254\201\255\042\000\042\000\
\042\000\042\000\042\000\042\000\042\000\042\000\206\255\168\255\
\000\000\035\001\035\001\035\001\035\001\000\000\016\255\000\000\
\040\255\220\255\000\000\223\255\224\255\228\255\000\000\062\255\
\225\255\247\255\125\255\192\000\192\000\000\255\028\000\234\255\
\232\255\253\255\190\255\190\255\190\255\190\255\035\001\035\001\
\000\000\105\001\044\255\249\255\000\000\250\255\168\255\252\255\
\000\000\007\000\000\000\016\000\000\000\019\000\020\000\021\000\
\029\000\000\000\000\000\000\000\009\255\000\000\042\000\000\000\
\000\000\070\001\000\000\251\254\003\255\003\255\000\000\000\000\
\031\000\040\000\041\000\026\000\048\000\000\000\000\000\053\000\
\000\000\000\000\050\000\055\000\000\000\056\000\116\255\234\254\
\070\001\000\000\112\255\249\255\000\000\070\001\249\255\102\000\
\107\000\054\000\000\000\000\000\108\000\109\000\114\000\115\000\
\000\000\000\000\000\000\000\000\116\000\118\000\000\000\153\000\
\000\000\151\000\186\000\003\255\003\255\000\000\070\001\078\000\
\070\001\000\000\000\000\239\000\194\000\000\000\000\000\193\000\
\203\000\000\000\204\000\205\000\208\000\209\000\196\000\000\000\
\000\000\239\000\210\000\239\254\000\000\000\000\000\000\000\000\
\070\001\000\000\000\000\206\000\000\000\000\000\195\000\211\000\
\215\000\000\000\216\000\000\000\003\255\000\000\247\000\239\254\
\214\000\000\000\000\000\000\000\249\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\251\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\134\255\000\000\160\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017\000\
\000\000\000\000\000\000\000\000\075\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\253\000\000\000\000\000\000\000\000\000\254\000\000\000\216\001\
\204\001\238\001\227\001\188\255\211\255\023\255\214\255\000\000\
\000\000\255\000\160\001\182\001\185\255\229\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\002\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\025\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\098\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\180\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\020\255\000\000\
\032\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\247\001\000\000\000\000\000\000\000\000\000\000\000\000\238\255\
\000\000\203\255\000\000\144\001\177\255\000\000\220\001\157\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\001\
\136\255\000\000\174\255\000\000\000\000\142\001\000\000\056\255\
\237\255\000\000\000\000\000\000\114\001\243\001\000\000\000\000\
\000\000\064\001\026\001\000\000\000\000\000\000\000\000\068\001\
\000\000\000\000\000\000\000\000\098\001\000\000\000\000\101\001\
\000\000\000\000\000\000\000\000\000\000\000\000\030\001\000\000\
\143\255\000\000"

let yytablesize = 772
let yytable = "\023\000\
\011\000\057\000\056\000\129\000\057\000\061\000\113\000\154\000\
\228\000\001\000\201\000\119\000\120\000\121\000\122\000\192\000\
\159\000\139\000\123\000\124\000\125\000\126\000\221\000\044\000\
\019\000\222\000\125\000\044\000\111\000\135\000\223\000\130\000\
\131\000\137\000\202\000\021\000\140\000\141\000\132\000\133\000\
\160\000\057\000\061\000\228\000\130\000\131\000\154\000\155\000\
\156\000\157\000\158\000\132\000\133\000\063\000\228\000\130\000\
\131\000\228\000\193\000\194\000\195\000\022\000\132\000\133\000\
\019\001\144\000\145\000\146\000\147\000\148\000\149\000\150\000\
\151\000\119\000\120\000\066\000\168\000\137\000\072\000\066\000\
\066\000\066\000\174\000\198\000\175\000\176\000\066\000\066\000\
\066\000\066\000\066\000\066\000\064\000\066\000\066\000\066\000\
\066\000\066\000\066\000\066\000\066\000\066\000\066\000\066\000\
\066\000\066\000\066\000\066\000\066\000\066\000\066\000\066\000\
\066\000\066\000\066\000\066\000\066\000\066\000\066\000\066\000\
\066\000\066\000\066\000\066\000\066\000\066\000\066\000\066\000\
\066\000\066\000\079\000\066\000\232\000\066\000\068\000\235\000\
\119\000\120\000\068\000\122\000\080\000\012\001\057\000\171\000\
\013\001\068\000\068\000\068\000\068\000\068\000\068\000\081\000\
\068\000\068\000\068\000\068\000\068\000\068\000\216\000\217\000\
\065\000\193\000\194\000\195\000\065\000\075\000\057\000\199\000\
\112\000\023\000\205\000\065\000\065\000\065\000\065\000\065\000\
\065\000\114\000\065\000\065\000\065\000\065\000\065\000\065\000\
\162\000\060\000\162\000\116\000\042\000\060\000\227\000\128\000\
\042\000\136\000\057\000\233\000\060\000\060\000\060\000\060\000\
\060\000\060\000\143\000\060\000\060\000\060\000\060\000\042\000\
\042\000\042\000\152\000\043\000\132\000\133\000\045\000\043\000\
\248\000\249\000\045\000\057\000\250\000\057\000\199\000\091\000\
\161\000\227\000\162\000\163\000\164\000\061\000\043\000\043\000\
\043\000\061\000\045\000\165\000\227\000\120\000\166\000\227\000\
\061\000\061\000\061\000\061\000\061\000\061\000\018\001\061\000\
\061\000\061\000\061\000\117\000\183\000\167\000\181\000\118\000\
\185\000\026\001\119\000\120\000\121\000\122\000\119\000\120\000\
\121\000\122\000\186\000\130\000\131\000\123\000\124\000\125\000\
\126\000\048\000\132\000\133\000\187\000\048\000\188\000\189\000\
\190\000\003\000\004\000\005\000\048\000\048\000\048\000\048\000\
\210\000\191\000\207\000\048\000\048\000\048\000\048\000\119\000\
\120\000\121\000\122\000\208\000\209\000\082\000\123\000\124\000\
\211\000\083\000\084\000\085\000\086\000\212\000\213\000\214\000\
\215\000\087\000\238\000\088\000\006\000\007\000\008\000\009\000\
\010\000\089\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\038\000\
\039\000\040\000\041\000\042\000\043\000\044\000\045\000\046\000\
\047\000\048\000\090\000\049\000\050\000\051\000\052\000\053\000\
\054\000\091\000\055\000\134\000\022\000\164\000\065\000\065\000\
\065\000\236\000\119\000\120\000\121\000\122\000\237\000\239\000\
\240\000\123\000\124\000\125\000\126\000\241\000\175\000\242\000\
\243\000\244\000\065\000\065\000\065\000\065\000\065\000\065\000\
\065\000\065\000\065\000\065\000\065\000\065\000\065\000\065\000\
\065\000\065\000\065\000\065\000\065\000\065\000\065\000\065\000\
\065\000\065\000\060\000\065\000\065\000\065\000\065\000\065\000\
\065\000\245\000\065\000\246\000\065\000\067\000\068\000\069\000\
\070\000\071\000\072\000\073\000\074\000\075\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\038\000\039\000\040\000\041\000\042\000\
\043\000\044\000\045\000\046\000\047\000\048\000\247\000\049\000\
\050\000\051\000\052\000\053\000\054\000\005\001\055\000\004\001\
\022\000\255\000\011\001\119\000\120\000\121\000\122\000\006\001\
\007\001\008\001\123\000\009\001\020\001\010\001\014\001\024\001\
\025\001\023\001\021\001\255\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\037\000\038\000\039\000\040\000\041\000\042\000\043\000\044\000\
\045\000\046\000\047\000\048\000\255\000\049\000\050\000\051\000\
\052\000\053\000\054\000\027\001\055\000\030\001\022\000\108\000\
\014\000\052\000\009\000\020\000\142\000\036\000\089\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\038\000\039\000\040\000\041\000\
\042\000\043\000\044\000\045\000\046\000\047\000\048\000\140\000\
\049\000\050\000\051\000\052\000\053\000\054\000\123\000\055\000\
\184\000\022\000\083\000\084\000\110\000\169\000\204\000\065\000\
\253\000\028\001\087\000\252\000\231\000\229\000\029\001\000\000\
\000\000\000\000\089\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\038\000\039\000\040\000\041\000\042\000\043\000\044\000\045\000\
\046\000\047\000\048\000\090\000\049\000\050\000\051\000\052\000\
\053\000\054\000\091\000\055\000\000\000\022\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\038\000\039\000\040\000\041\000\042\000\
\043\000\044\000\045\000\046\000\047\000\048\000\000\000\049\000\
\050\000\051\000\052\000\053\000\054\000\000\000\055\000\000\000\
\022\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\170\000\039\000\
\040\000\041\000\042\000\043\000\044\000\045\000\046\000\047\000\
\048\000\000\000\049\000\050\000\051\000\052\000\053\000\054\000\
\054\000\055\000\000\000\022\000\054\000\000\000\000\000\000\000\
\000\000\000\000\000\000\054\000\054\000\054\000\054\000\000\000\
\000\000\000\000\054\000\054\000\054\000\054\000\055\000\000\000\
\000\000\000\000\055\000\000\000\000\000\000\000\000\000\000\000\
\000\000\055\000\055\000\055\000\055\000\000\000\000\000\000\000\
\055\000\055\000\055\000\055\000\039\000\000\000\000\000\000\000\
\039\000\000\000\000\000\000\000\000\000\000\000\000\000\039\000\
\038\000\039\000\039\000\000\000\038\000\000\000\039\000\039\000\
\039\000\039\000\000\000\041\000\000\000\038\000\038\000\041\000\
\000\000\000\000\038\000\038\000\038\000\038\000\040\000\000\000\
\041\000\000\000\040\000\000\000\000\000\041\000\041\000\041\000\
\041\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\040\000\040\000\040\000\040\000"

let yycheck = "\019\000\
\000\000\021\000\021\000\103\000\024\000\024\000\089\000\128\000\
\209\000\001\000\016\001\012\001\013\001\014\001\015\001\007\001\
\001\001\035\001\019\001\020\001\001\001\022\001\045\001\001\001\
\004\001\048\001\007\001\005\001\082\000\112\000\053\001\016\001\
\017\001\116\000\040\001\004\001\054\001\055\001\023\001\024\001\
\001\001\061\000\061\000\244\000\016\001\017\001\167\000\130\000\
\131\000\132\000\133\000\023\001\024\001\001\001\255\000\016\001\
\017\001\002\001\050\001\051\001\052\001\059\001\023\001\024\001\
\009\001\119\000\120\000\121\000\122\000\123\000\124\000\125\000\
\126\000\012\001\013\001\001\001\159\000\160\000\004\001\005\001\
\006\001\007\001\039\001\183\000\041\001\042\001\012\001\013\001\
\014\001\015\001\016\001\017\001\002\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\005\001\050\001\051\001\052\001\053\001\
\054\001\055\001\002\001\057\001\212\000\059\001\001\001\215\000\
\012\001\013\001\005\001\015\001\001\001\255\000\162\000\162\000\
\002\001\012\001\013\001\014\001\015\001\016\001\017\001\024\001\
\019\001\020\001\021\001\022\001\023\001\024\001\043\001\044\001\
\001\001\050\001\051\001\052\001\005\001\036\001\186\000\186\000\
\004\001\189\000\190\000\012\001\013\001\014\001\015\001\016\001\
\017\001\002\001\019\001\020\001\021\001\022\001\023\001\024\001\
\005\001\001\001\007\001\004\001\001\001\005\001\209\000\006\001\
\005\001\049\001\214\000\214\000\012\001\013\001\014\001\015\001\
\016\001\017\001\002\001\019\001\020\001\021\001\022\001\020\001\
\021\001\022\001\005\001\001\001\023\001\024\001\001\001\005\001\
\236\000\237\000\005\001\239\000\239\000\241\000\241\000\056\001\
\005\001\244\000\004\001\004\001\001\001\001\001\020\001\021\001\
\022\001\005\001\021\001\002\001\255\000\013\001\007\001\002\001\
\012\001\013\001\014\001\015\001\016\001\017\001\009\001\019\001\
\020\001\021\001\022\001\001\001\003\001\001\001\006\001\005\001\
\005\001\021\001\012\001\013\001\014\001\015\001\012\001\013\001\
\014\001\015\001\004\001\016\001\017\001\019\001\020\001\021\001\
\022\001\001\001\023\001\024\001\005\001\005\001\004\001\004\001\
\004\001\025\001\026\001\027\001\012\001\013\001\014\001\015\001\
\007\001\005\001\004\001\019\001\020\001\021\001\022\001\012\001\
\013\001\014\001\015\001\004\001\004\001\004\001\019\001\020\001\
\001\001\008\001\009\001\010\001\011\001\001\001\005\001\001\001\
\001\001\016\001\005\001\018\001\060\001\061\001\062\001\063\001\
\064\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\057\001\005\001\059\001\004\001\005\001\006\001\
\007\001\004\001\012\001\013\001\014\001\015\001\004\001\004\001\
\004\001\019\001\020\001\021\001\022\001\004\001\041\001\005\001\
\005\001\004\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\005\001\050\001\051\001\052\001\053\001\054\001\
\055\001\001\001\057\001\005\001\059\001\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\005\001\050\001\
\051\001\052\001\053\001\054\001\055\001\005\001\057\001\006\001\
\059\001\006\001\007\001\012\001\013\001\014\001\015\001\005\001\
\005\001\005\001\019\001\004\001\007\001\005\001\005\001\001\001\
\001\001\007\001\024\001\006\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\006\001\050\001\051\001\052\001\
\053\001\054\001\055\001\005\001\057\001\005\001\059\001\005\001\
\001\001\005\001\005\001\013\000\117\000\007\001\005\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\007\001\
\050\001\051\001\052\001\053\001\054\001\055\001\007\001\057\001\
\167\000\059\001\008\001\009\001\081\000\160\000\189\000\061\000\
\241\000\024\001\016\001\240\000\211\000\209\000\025\001\255\255\
\255\255\255\255\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\255\255\059\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\255\255\050\001\
\051\001\052\001\053\001\054\001\055\001\255\255\057\001\255\255\
\059\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\255\255\050\001\051\001\052\001\053\001\054\001\055\001\
\001\001\057\001\255\255\059\001\005\001\255\255\255\255\255\255\
\255\255\255\255\255\255\012\001\013\001\014\001\015\001\255\255\
\255\255\255\255\019\001\020\001\021\001\022\001\001\001\255\255\
\255\255\255\255\005\001\255\255\255\255\255\255\255\255\255\255\
\255\255\012\001\013\001\014\001\015\001\255\255\255\255\255\255\
\019\001\020\001\021\001\022\001\001\001\255\255\255\255\255\255\
\005\001\255\255\255\255\255\255\255\255\255\255\255\255\012\001\
\001\001\014\001\015\001\255\255\005\001\255\255\019\001\020\001\
\021\001\022\001\255\255\001\001\255\255\014\001\015\001\005\001\
\255\255\255\255\019\001\020\001\021\001\022\001\001\001\255\255\
\014\001\255\255\005\001\255\255\255\255\019\001\020\001\021\001\
\022\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\019\001\020\001\021\001\022\001"

let yynames_const = "\
  Comma\000\
  Dot\000\
  Semicolumn\000\
  LeftParen\000\
  RightParen\000\
  LBrace\000\
  RBrace\000\
  True\000\
  False\000\
  ForAll\000\
  Exists\000\
  And\000\
  NegAnd\000\
  Or\000\
  NegOr\000\
  Equality\000\
  NegEquality\000\
  Negation\000\
  ImplicationLR\000\
  ImplicationRL\000\
  Equivalence\000\
  NegEquivalence\000\
  Plus\000\
  Minus\000\
  EOF\000\
  "

let yynames_block = "\
  CNF\000\
  FOF\000\
  Include\000\
  Axiom\000\
  Hypothesis\000\
  Conjecture\000\
  Negated_conjecture\000\
  Lemma\000\
  Theorem\000\
  Plain\000\
  Unknown\000\
  Derived\000\
  Equal\000\
  Inference\000\
  Theory\000\
  AC\000\
  File\000\
  Creator\000\
  Description\000\
  Iquote\000\
  Status\000\
  Thm\000\
  Sat\000\
  Refutation\000\
  PositiveInteger\000\
  FormulaItem\000\
  InferenceItem\000\
  GeneralFunction\000\
  InferenceInfo\000\
  DagSource\000\
  ExternalSource\000\
  UpperWord\000\
  LowerWord\000\
  String\000\
  QuotedStr\000\
  CommentPercent\000\
  CommentEprover\000\
  CommentStar\000\
  AnnotationPercent\000\
  AnnotationStar\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Parser_types.parsing_type) in
    Obj.repr(
# 61 "src/parser_tptp.mly"
             (_1::_2)
# 609 "src/parser_tptp.ml"
               : Parser_types.parsing_type))
; (fun __caml_parser_env ->
    Obj.repr(
# 62 "src/parser_tptp.mly"
             ([])
# 615 "src/parser_tptp.ml"
               : Parser_types.parsing_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'annotated_formula) in
    Obj.repr(
# 67 "src/parser_tptp.mly"
                     (_1)
# 622 "src/parser_tptp.ml"
               : 'unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'include_file) in
    Obj.repr(
# 68 "src/parser_tptp.mly"
                     (_1)
# 629 "src/parser_tptp.ml"
               : 'unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'comment) in
    Obj.repr(
# 69 "src/parser_tptp.mly"
                     (_1)
# 636 "src/parser_tptp.ml"
               : 'unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'annotation) in
    Obj.repr(
# 70 "src/parser_tptp.mly"
                     (_1)
# 643 "src/parser_tptp.ml"
               : 'unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : 'language) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : 'name) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : 'formula_type) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    Obj.repr(
# 76 "src/parser_tptp.mly"
                                      (Formula(_1,_3,_5,_7,[]))
# 653 "src/parser_tptp.ml"
               : 'annotated_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 9 : 'language) in
    let _3 = (Parsing.peek_val __caml_parser_env 7 : 'name) in
    let _5 = (Parsing.peek_val __caml_parser_env 5 : 'formula_type) in
    let _7 = (Parsing.peek_val __caml_parser_env 3 : 'fol_formula) in
    let _8 = (Parsing.peek_val __caml_parser_env 2 : 'extra_annotations) in
    Obj.repr(
# 79 "src/parser_tptp.mly"
                                                        (Formula(_1,_3,_5,_7,[_8]))
# 664 "src/parser_tptp.ml"
               : 'annotated_formula))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'source) in
    Obj.repr(
# 83 "src/parser_tptp.mly"
               (Source (_2))
# 671 "src/parser_tptp.ml"
               : 'extra_annotations))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'source) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'useful_info) in
    Obj.repr(
# 84 "src/parser_tptp.mly"
                                 (Source_UsefulInfo (_2,_4))
# 679 "src/parser_tptp.ml"
               : 'extra_annotations))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 89 "src/parser_tptp.mly"
      (CNF)
# 686 "src/parser_tptp.ml"
               : 'language))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 90 "src/parser_tptp.mly"
      (FOF)
# 693 "src/parser_tptp.ml"
               : 'language))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'user_type) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'source_type) in
    Obj.repr(
# 97 "src/parser_tptp.mly"
                                 (UserSourceType(_1,_3))
# 701 "src/parser_tptp.ml"
               : 'formula_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'user_type) in
    Obj.repr(
# 98 "src/parser_tptp.mly"
               (UserType(_1))
# 708 "src/parser_tptp.ml"
               : 'formula_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'source_type) in
    Obj.repr(
# 99 "src/parser_tptp.mly"
                 (SourceType(_1))
# 715 "src/parser_tptp.ml"
               : 'formula_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 104 "src/parser_tptp.mly"
          (Axiom)
# 722 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 104 "src/parser_tptp.mly"
                             (Hypothesis)
# 729 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 105 "src/parser_tptp.mly"
               (Conjecture)
# 736 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 105 "src/parser_tptp.mly"
                                                (Negated_conjecture)
# 743 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 106 "src/parser_tptp.mly"
          (Lemma)
# 750 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 106 "src/parser_tptp.mly"
                          (Theorem)
# 757 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 106 "src/parser_tptp.mly"
                                          (Plain)
# 764 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 106 "src/parser_tptp.mly"
                                                          (Unknown)
# 771 "src/parser_tptp.ml"
               : 'user_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 108 "src/parser_tptp.mly"
                       (Derived)
# 778 "src/parser_tptp.ml"
               : 'source_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'literal_formula) in
    Obj.repr(
# 125 "src/parser_tptp.mly"
                   (_1)
# 785 "src/parser_tptp.ml"
               : 'fol_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'binary_formula) in
    Obj.repr(
# 126 "src/parser_tptp.mly"
                   (_1)
# 792 "src/parser_tptp.ml"
               : 'fol_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'atomic_formula) in
    Obj.repr(
# 130 "src/parser_tptp.mly"
                  (_1)
# 799 "src/parser_tptp.ml"
               : 'literal_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_formula) in
    Obj.repr(
# 131 "src/parser_tptp.mly"
                  (_1)
# 806 "src/parser_tptp.ml"
               : 'literal_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'quantified_formula) in
    Obj.repr(
# 135 "src/parser_tptp.mly"
                     (_1)
# 813 "src/parser_tptp.ml"
               : 'atomic_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'bracketed_formula) in
    Obj.repr(
# 136 "src/parser_tptp.mly"
                    (_1)
# 820 "src/parser_tptp.ml"
               : 'atomic_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'atom) in
    Obj.repr(
# 137 "src/parser_tptp.mly"
       (Atom _1)
# 827 "src/parser_tptp.ml"
               : 'atomic_formula))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'fol_formula) in
    Obj.repr(
# 140 "src/parser_tptp.mly"
                                                     (_2)
# 834 "src/parser_tptp.ml"
               : 'bracketed_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'quantifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'variables) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'literal_formula) in
    Obj.repr(
# 152 "src/parser_tptp.mly"
 (QuantifiedFormula(_1,_3,_6))
# 843 "src/parser_tptp.ml"
               : 'quantified_formula))
; (fun __caml_parser_env ->
    Obj.repr(
# 157 "src/parser_tptp.mly"
         (Exists)
# 849 "src/parser_tptp.ml"
               : 'quantifier))
; (fun __caml_parser_env ->
    Obj.repr(
# 158 "src/parser_tptp.mly"
         (ForAll)
# 855 "src/parser_tptp.ml"
               : 'quantifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'variable) in
    Obj.repr(
# 162 "src/parser_tptp.mly"
             ([_1])
# 862 "src/parser_tptp.ml"
               : 'variables))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'variable) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'variables) in
    Obj.repr(
# 163 "src/parser_tptp.mly"
                             (_1::_3)
# 870 "src/parser_tptp.ml"
               : 'variables))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 190 "src/parser_tptp.mly"
                                         (BinaryFormula(And,_1,_3))
# 878 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 191 "src/parser_tptp.mly"
                                         (BinaryFormula(NegAnd,_1,_3))
# 886 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 192 "src/parser_tptp.mly"
                                         (BinaryFormula(Or,_1,_3))
# 894 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 193 "src/parser_tptp.mly"
                                         (BinaryFormula(NegOr,_1,_3))
# 902 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 194 "src/parser_tptp.mly"
                                         (BinaryFormula(ImplicationLR,_1,_3))
# 910 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 195 "src/parser_tptp.mly"
                                         (BinaryFormula(ImplicationRL,_1,_3))
# 918 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 196 "src/parser_tptp.mly"
                                         (BinaryFormula(Equivalence,_1,_3))
# 926 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'fol_formula) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'fol_formula) in
    Obj.repr(
# 197 "src/parser_tptp.mly"
                                         (BinaryFormula(NegEquivalence,_1,_3))
# 934 "src/parser_tptp.ml"
               : 'binary_formula))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_connective) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'literal_formula) in
    Obj.repr(
# 206 "src/parser_tptp.mly"
(UnaryFormula(_1,_2))
# 942 "src/parser_tptp.ml"
               : 'unary_formula))
; (fun __caml_parser_env ->
    Obj.repr(
# 221 "src/parser_tptp.mly"
                             (Negation)
# 948 "src/parser_tptp.ml"
               : 'unary_connective))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 225 "src/parser_tptp.mly"
            (_1)
# 955 "src/parser_tptp.ml"
               : 'atom))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'theory_term) in
    Obj.repr(
# 230 "src/parser_tptp.mly"
               (TheoryTerm (_1))
# 962 "src/parser_tptp.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'user_term) in
    Obj.repr(
# 231 "src/parser_tptp.mly"
             (UserTerm (_1))
# 969 "src/parser_tptp.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'variable) in
    Obj.repr(
# 232 "src/parser_tptp.mly"
            (Var(_1))
# 976 "src/parser_tptp.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 236 "src/parser_tptp.mly"
        ([_1])
# 983 "src/parser_tptp.ml"
               : 'arguments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arguments) in
    Obj.repr(
# 237 "src/parser_tptp.mly"
                       (_1::_3)
# 991 "src/parser_tptp.ml"
               : 'arguments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 241 "src/parser_tptp.mly"
                           (Equality(_1,_3))
# 999 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 242 "src/parser_tptp.mly"
                           (NegEquality(_1,_3))
# 1007 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'term) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'term) in
    Obj.repr(
# 243 "src/parser_tptp.mly"
                                                  (Equality(_3,_5))
# 1015 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    Obj.repr(
# 244 "src/parser_tptp.mly"
         (True)
# 1021 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    Obj.repr(
# 245 "src/parser_tptp.mly"
          (False)
# 1027 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'number) in
    Obj.repr(
# 246 "src/parser_tptp.mly"
          (_1)
# 1034 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 247 "src/parser_tptp.mly"
                  (Plus(_1,_3))
# 1042 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 248 "src/parser_tptp.mly"
                   (Minus(_1,_3))
# 1050 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 249 "src/parser_tptp.mly"
                               (UnaryMinus(_2))
# 1057 "src/parser_tptp.ml"
               : 'theory_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'constant) in
    Obj.repr(
# 253 "src/parser_tptp.mly"
            (_1)
# 1064 "src/parser_tptp.ml"
               : 'user_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'name) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'arguments) in
    Obj.repr(
# 254 "src/parser_tptp.mly"
                                       (Fun(_1,_3))
# 1072 "src/parser_tptp.ml"
               : 'user_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'name) in
    Obj.repr(
# 258 "src/parser_tptp.mly"
        (Fun(_1,[]))
# 1079 "src/parser_tptp.ml"
               : 'constant))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'quoted_string) in
    Obj.repr(
# 259 "src/parser_tptp.mly"
                 (Fun(_1,[]))
# 1086 "src/parser_tptp.ml"
               : 'constant))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 263 "src/parser_tptp.mly"
                (_1)
# 1093 "src/parser_tptp.ml"
               : 'variable))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 266 "src/parser_tptp.mly"
                   (PositiveInteger(int_of_string _1))
# 1100 "src/parser_tptp.ml"
               : 'number))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decimal_part) in
    Obj.repr(
# 268 "src/parser_tptp.mly"
     (RealNumber(int_of_string _1, int_of_string _2))
# 1108 "src/parser_tptp.ml"
               : 'number))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 270 "src/parser_tptp.mly"
                                    (_2)
# 1115 "src/parser_tptp.ml"
               : 'decimal_part))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'lower_word) in
    Obj.repr(
# 272 "src/parser_tptp.mly"
                  (_1)
# 1122 "src/parser_tptp.ml"
               : 'name))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'quoted_string) in
    Obj.repr(
# 273 "src/parser_tptp.mly"
                (_1)
# 1129 "src/parser_tptp.ml"
               : 'name))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 275 "src/parser_tptp.mly"
                           (disquote_string _1)
# 1136 "src/parser_tptp.ml"
               : 'quoted_string))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 278 "src/parser_tptp.mly"
            (_1)
# 1143 "src/parser_tptp.ml"
               : 'lower_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'key_word) in
    Obj.repr(
# 279 "src/parser_tptp.mly"
            (_1)
# 1150 "src/parser_tptp.ml"
               : 'lower_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 282 "src/parser_tptp.mly"
      (_1)
# 1157 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 282 "src/parser_tptp.mly"
                (_1)
# 1164 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 282 "src/parser_tptp.mly"
                              (_1)
# 1171 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 283 "src/parser_tptp.mly"
        (_1)
# 1178 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 283 "src/parser_tptp.mly"
                         (_1)
# 1185 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 283 "src/parser_tptp.mly"
                                          (_1)
# 1192 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 284 "src/parser_tptp.mly"
                     (_1)
# 1199 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 284 "src/parser_tptp.mly"
                                  (_1)
# 1206 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 284 "src/parser_tptp.mly"
                                                (_1)
# 1213 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 285 "src/parser_tptp.mly"
        (_1)
# 1220 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 285 "src/parser_tptp.mly"
                      (_1)
# 1227 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 285 "src/parser_tptp.mly"
                                     (_1)
# 1234 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 286 "src/parser_tptp.mly"
        (_1)
# 1241 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 286 "src/parser_tptp.mly"
                        (_1)
# 1248 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 286 "src/parser_tptp.mly"
                                     (_1)
# 1255 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 286 "src/parser_tptp.mly"
                                             (_1)
# 1262 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 286 "src/parser_tptp.mly"
                                                         (_1)
# 1269 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 287 "src/parser_tptp.mly"
          (_1)
# 1276 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 287 "src/parser_tptp.mly"
                            (_1)
# 1283 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 287 "src/parser_tptp.mly"
                                         (_1)
# 1290 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 288 "src/parser_tptp.mly"
         (_1)
# 1297 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 288 "src/parser_tptp.mly"
                   (_1)
# 1304 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 288 "src/parser_tptp.mly"
                             (_1)
# 1311 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 288 "src/parser_tptp.mly"
                                              (_1)
# 1318 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 289 "src/parser_tptp.mly"
              (_1)
# 1325 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 289 "src/parser_tptp.mly"
                                 (_1)
# 1332 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 289 "src/parser_tptp.mly"
                                                      (_1)
# 1339 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 290 "src/parser_tptp.mly"
                (_1)
# 1346 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 290 "src/parser_tptp.mly"
                                (_1)
# 1353 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 290 "src/parser_tptp.mly"
                                                     (_1)
# 1360 "src/parser_tptp.ml"
               : 'key_word))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'file_name) in
    Obj.repr(
# 297 "src/parser_tptp.mly"
  (Include(_3,[]))
# 1368 "src/parser_tptp.ml"
               : 'include_file))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'file_name) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'formula_selection) in
    Obj.repr(
# 299 "src/parser_tptp.mly"
  (Include(_3,_4))
# 1377 "src/parser_tptp.ml"
               : 'include_file))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'name) in
    Obj.repr(
# 303 "src/parser_tptp.mly"
                           ([_1])
# 1384 "src/parser_tptp.ml"
               : 'formula_selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'name) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'formula_selection) in
    Obj.repr(
# 304 "src/parser_tptp.mly"
                           (_1::_2)
# 1392 "src/parser_tptp.ml"
               : 'formula_selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'quoted_string) in
    Obj.repr(
# 307 "src/parser_tptp.mly"
                          (_1)
# 1399 "src/parser_tptp.ml"
               : 'file_name))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 314 "src/parser_tptp.mly"
                 (Comment (_1))
# 1406 "src/parser_tptp.ml"
               : 'comment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 315 "src/parser_tptp.mly"
                 (Comment (_1))
# 1413 "src/parser_tptp.ml"
               : 'comment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 316 "src/parser_tptp.mly"
                 (CommentEprover (_1))
# 1420 "src/parser_tptp.ml"
               : 'comment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 322 "src/parser_tptp.mly"
                    (Annotation (_1))
# 1427 "src/parser_tptp.ml"
               : 'annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 323 "src/parser_tptp.mly"
                    (Annotation (_1))
# 1434 "src/parser_tptp.ml"
               : 'annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'dag_source) in
    Obj.repr(
# 428 "src/parser_tptp.mly"
                                            (foo)
# 1442 "src/parser_tptp.ml"
               : 'source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'external_source) in
    Obj.repr(
# 429 "src/parser_tptp.mly"
                                                        (foo)
# 1450 "src/parser_tptp.ml"
               : 'source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 431 "src/parser_tptp.mly"
          (foo)
# 1457 "src/parser_tptp.ml"
               : 'source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'name) in
    Obj.repr(
# 435 "src/parser_tptp.mly"
        (foo)
# 1464 "src/parser_tptp.ml"
               : 'dag_source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'inference_record) in
    Obj.repr(
# 436 "src/parser_tptp.mly"
                    (foo)
# 1471 "src/parser_tptp.ml"
               : 'dag_source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 9 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 7 : 'inference_rule) in
    let _5 = (Parsing.peek_val __caml_parser_env 5 : 'useful_info) in
    let _8 = (Parsing.peek_val __caml_parser_env 2 : 'parent_info) in
    Obj.repr(
# 442 "src/parser_tptp.mly"
  (foo)
# 1481 "src/parser_tptp.ml"
               : 'inference_record))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'name) in
    Obj.repr(
# 445 "src/parser_tptp.mly"
                      (foo)
# 1488 "src/parser_tptp.ml"
               : 'inference_rule))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parent_info_unit) in
    Obj.repr(
# 455 "src/parser_tptp.mly"
                   (foo)
# 1495 "src/parser_tptp.ml"
               : 'parent_info))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parent_info_unit) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parent_info) in
    Obj.repr(
# 456 "src/parser_tptp.mly"
                                      (foo)
# 1503 "src/parser_tptp.ml"
               : 'parent_info))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'source) in
    Obj.repr(
# 460 "src/parser_tptp.mly"
          (foo)
# 1510 "src/parser_tptp.ml"
               : 'parent_info_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'source) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'parent_details) in
    Obj.repr(
# 461 "src/parser_tptp.mly"
                         (foo)
# 1518 "src/parser_tptp.ml"
               : 'parent_info_unit))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'quoted_string) in
    Obj.repr(
# 464 "src/parser_tptp.mly"
                                      (foo)
# 1525 "src/parser_tptp.ml"
               : 'parent_details))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'theory_name) in
    Obj.repr(
# 469 "src/parser_tptp.mly"
 (foo)
# 1533 "src/parser_tptp.ml"
               : 'theory))
; (fun __caml_parser_env ->
    Obj.repr(
# 472 "src/parser_tptp.mly"
            (foo)
# 1539 "src/parser_tptp.ml"
               : 'theory_name))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 473 "src/parser_tptp.mly"
     (foo)
# 1546 "src/parser_tptp.ml"
               : 'theory_name))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'file_source) in
    Obj.repr(
# 479 "src/parser_tptp.mly"
                  (foo)
# 1553 "src/parser_tptp.ml"
               : 'external_source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'creator_source) in
    Obj.repr(
# 480 "src/parser_tptp.mly"
                  (foo)
# 1560 "src/parser_tptp.ml"
               : 'external_source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'theory) in
    Obj.repr(
# 481 "src/parser_tptp.mly"
                  (foo)
# 1567 "src/parser_tptp.ml"
               : 'external_source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'file_name) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'file_node_name) in
    Obj.repr(
# 485 "src/parser_tptp.mly"
(foo)
# 1576 "src/parser_tptp.ml"
               : 'file_source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'name) in
    Obj.repr(
# 489 "src/parser_tptp.mly"
        (foo)
# 1583 "src/parser_tptp.ml"
               : 'file_node_name))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'creator_name) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'useful_info) in
    Obj.repr(
# 494 "src/parser_tptp.mly"
 (foo)
# 1592 "src/parser_tptp.ml"
               : 'creator_source))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'quoted_string) in
    Obj.repr(
# 496 "src/parser_tptp.mly"
                              (foo)
# 1599 "src/parser_tptp.ml"
               : 'creator_name))
; (fun __caml_parser_env ->
    Obj.repr(
# 504 "src/parser_tptp.mly"
                 (foo)
# 1605 "src/parser_tptp.ml"
               : 'useful_info))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'info_items) in
    Obj.repr(
# 505 "src/parser_tptp.mly"
                            (foo)
# 1612 "src/parser_tptp.ml"
               : 'useful_info))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'info_item) in
    Obj.repr(
# 509 "src/parser_tptp.mly"
             (foo)
# 1619 "src/parser_tptp.ml"
               : 'info_items))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'info_item) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'info_item) in
    Obj.repr(
# 510 "src/parser_tptp.mly"
                             (foo)
# 1627 "src/parser_tptp.ml"
               : 'info_items))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'formula_item) in
    Obj.repr(
# 528 "src/parser_tptp.mly"
                                                           (foo)
# 1635 "src/parser_tptp.ml"
               : 'info_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'inference_item) in
    Obj.repr(
# 529 "src/parser_tptp.mly"
                                                           (foo)
# 1643 "src/parser_tptp.ml"
               : 'info_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'general_function) in
    Obj.repr(
# 530 "src/parser_tptp.mly"
                                                           (foo)
# 1651 "src/parser_tptp.ml"
               : 'info_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'description_item) in
    Obj.repr(
# 536 "src/parser_tptp.mly"
                   (foo)
# 1658 "src/parser_tptp.ml"
               : 'formula_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iquote_item) in
    Obj.repr(
# 537 "src/parser_tptp.mly"
                  (foo)
# 1665 "src/parser_tptp.ml"
               : 'formula_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'quoted_string) in
    Obj.repr(
# 541 "src/parser_tptp.mly"
(foo)
# 1673 "src/parser_tptp.ml"
               : 'description_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'quoted_string) in
    Obj.repr(
# 544 "src/parser_tptp.mly"
 (foo)
# 1681 "src/parser_tptp.ml"
               : 'iquote_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'inference_status) in
    Obj.repr(
# 550 "src/parser_tptp.mly"
                   (foo)
# 1688 "src/parser_tptp.ml"
               : 'inference_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'refutation) in
    Obj.repr(
# 551 "src/parser_tptp.mly"
              (foo)
# 1695 "src/parser_tptp.ml"
               : 'inference_item))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'status_value) in
    Obj.repr(
# 559 "src/parser_tptp.mly"
    (foo)
# 1703 "src/parser_tptp.ml"
               : 'inference_status))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'inference_info) in
    Obj.repr(
# 560 "src/parser_tptp.mly"
                                                   (foo)
# 1711 "src/parser_tptp.ml"
               : 'inference_status))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'name) in
    Obj.repr(
# 564 "src/parser_tptp.mly"
      (foo)
# 1718 "src/parser_tptp.ml"
               : 'status_value))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'inference_rule) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'constant) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'general_list) in
    Obj.repr(
# 572 "src/parser_tptp.mly"
(foo)
# 1727 "src/parser_tptp.ml"
               : 'inference_info))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'file_source) in
    Obj.repr(
# 576 "src/parser_tptp.mly"
(foo)
# 1735 "src/parser_tptp.ml"
               : 'refutation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'general_function) in
    Obj.repr(
# 585 "src/parser_tptp.mly"
                   (foo)
# 1742 "src/parser_tptp.ml"
               : 'general_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'general_list) in
    Obj.repr(
# 588 "src/parser_tptp.mly"
               (foo)
# 1749 "src/parser_tptp.ml"
               : 'general_term))
; (fun __caml_parser_env ->
    Obj.repr(
# 592 "src/parser_tptp.mly"
                 (foo)
# 1755 "src/parser_tptp.ml"
               : 'general_list))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'general_arguments) in
    Obj.repr(
# 593 "src/parser_tptp.mly"
                                   (foo)
# 1762 "src/parser_tptp.ml"
               : 'general_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'constant) in
    Obj.repr(
# 598 "src/parser_tptp.mly"
           (foo)
# 1769 "src/parser_tptp.ml"
               : 'general_function))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'functor_name) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'general_arguments) in
    Obj.repr(
# 599 "src/parser_tptp.mly"
                                                       (foo)
# 1777 "src/parser_tptp.ml"
               : 'general_function))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'general_term) in
    Obj.repr(
# 603 "src/parser_tptp.mly"
                                   (foo)
# 1784 "src/parser_tptp.ml"
               : 'general_arguments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'general_term) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'general_arguments) in
    Obj.repr(
# 604 "src/parser_tptp.mly"
                                   (foo)
# 1792 "src/parser_tptp.ml"
               : 'general_arguments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'name) in
    Obj.repr(
# 609 "src/parser_tptp.mly"
                    (foo)
# 1799 "src/parser_tptp.ml"
               : 'functor_name))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Parser_types.parsing_type)
