/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package concurrent;

import logic.data.Clause;

public abstract class AbstractSimpleTaskProcedure<I, O> extends
		AbstractSimpleTaskFactory<I, O> {
    public static final Clause EMPTY_CLAUSE = new Clause();

	@Override
	public Task<I, O> create() {
		return new Task<I, O>() {

			boolean next = false;

			I input;

			public boolean hasNext() {
				return next;
			}

			public boolean input(I input) {
				next = true;
				this.input = input;
				return false;
			}

			public concurrent.Task.TaskInstance<O> next() {
				next = false;
				return new Task.TaskInstance<O>() {

					public O run() throws SearchFailureException {
						return AbstractSimpleTaskProcedure.this.run(input);
					}
				};
			}
		};
	}

	public abstract O run(I input)
		throws SearchFailureException;
	
}
