/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.datatype;

public class Triple<U, V, W> extends Tuple<U, Tuple<V, Tuple<W, Tuple>>> {

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Triple<U, V, W> other = (Triple<U, V, W>) obj;
        if (this.a != other.a && (this.a == null || !this.a.equals(other.a))) {
            return false;
        }
        if (this.b != other.b && (this.b == null || !this.b.equals(other.b))) {
            return false;
        }
        if (this.c != other.c && (this.c == null || !this.c.equals(other.c))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 97 * hash + (this.a != null ? this.a.hashCode() : 0);
        hash = 97 * hash + (this.b != null ? this.b.hashCode() : 0);
        hash = 97 * hash + (this.c != null ? this.c.hashCode() : 0);
        return hash;
    }
    U a;
    V b;
    W c;

    @Override
    public Object[] toArray() {
        return new Object[]{a, b, c};
    }

    public final U fst() {
        return a;
    }

    public final V snd() {
        return b;
    }

    public final W third() {
        return c;
    }

    public Triple(U a, V b, W c) {
        this.a = a;
        this.b = b;
        this.c = c;
    }
}
