/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.dynamic;

import jfp.environment.GenericEnvironment;
import jfp.environment.TypeVariableEnvironmentInterface;

public abstract class TypeASTDelegate<EA extends ExtensibleAST> extends ExtensibleASTDelegate<EA> {

    @Override
    public Object doVisitedBy(String visitor, EA ast, GenericEnvironment<String, Object> env, ExtensibleAST[] astn, GenericEnvironment<String, Object>[] envn) throws ASTException {
        if (visitor.equals(Term.UNIFY)) {
            return this.unify_env(ast, (TypeVariableEnvironmentInterface) env, astn[0], (TypeVariableEnvironmentInterface) envn[0]);

        } else if (visitor.equals(Term.TYPE_VARIABLES)) {
            return type_varaibles(ast, (TypeVariableEnvironmentInterface) env);

        } else if (visitor.equals(Term.INSTANTIATE)) {
            return instantiate(ast, (TypeVariableEnvironmentInterface) env);
        } else if (visitor.equals(Term.INST)) {
            return inst(ast, (TypeVariableEnvironmentInterface) env);
        } else {
            throw new ASTException();
        }
    }

    public abstract Object inst(ExtensibleAST ast, TypeVariableEnvironmentInterface env) throws ASTException;


    public abstract Object unify_env(ExtensibleAST ast, TypeVariableEnvironmentInterface env, ExtensibleAST extensibleAST, TypeVariableEnvironmentInterface interface1) throws ASTException;

    public abstract Object type_varaibles(ExtensibleAST ast, TypeVariableEnvironmentInterface env) throws ASTException;

    public abstract Object instantiate(ExtensibleAST ast, TypeVariableEnvironmentInterface env) throws ASTException;
}
