package jfp.environment;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jfp.datatype.Pair;
import jfp.dynamic.ASTException;
import jfp.dynamic.Scope;


public class TVarEnvironment implements TypeVariableEnvironmentInterface {

	Map<String, Object> varTable = new HashMap<String, Object>();

	GenericEnvironment<String, Object> context = null;
        /**
         * The context must be a global, immutable type context. Basically, only type constants are allowed
         * @param context
         */
	
	public TVarEnvironment(TypeVariableEnvironmentInterface context) {
		super();
		this.context = context;
	}

	public TVarEnvironment() {
		super();
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see jfp.dynamic.EnvironmentInterface#bindType(java.lang.String,
	 *      java.lang.Object)
	 */
	public void bindType(String vn, Object t) {
		this.varTable.put(vn, t);
		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see jfp.dynamic.EnvironmentInterface#getType(java.lang.String)
	 */
	public Object getType(String v) {
		Object type = this.varTable.get(v);
		
		if (type == null)
			if (this.context != null)
				try {
					type = this.context.get(v);
				} catch (ASTException e) {
					e.printStackTrace();
				}
	
		return type;
	}

	public void bindValue(String v, Object value) {
		this.bindType(v, value);
	}

	public Object get(String value_exp) throws ASTException {
		return this.getType(value_exp);
	}

	public GenericEnvironment<String, Object> getContext() {
		return this.context;
	}
        /**
         * The context must be a global, immutable type context. Basically, only type constants are allowed
         * @param env
         */

	public void setContext(GenericEnvironment<String, Object> env) {
		this.context=env;
	}


}
