/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.type;

import java.util.Arrays;

import jfp.dynamic.ExtensibleTypeAST;

public class TDisjointUnion extends ExtensibleTypeAST {
	protected TGenericType genericType;

	protected Object[] typeParameters;

	public TGenericType getGenericType() {
		return this.genericType;
	}
	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result
				+ ((genericType == null) ? 0 : genericType.hashCode());
		result = PRIME * result + Arrays.hashCode(typeParameters);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final TDisjointUnion other = (TDisjointUnion) obj;
		if (genericType == null) {
			if (other.genericType != null)
				return false;
		} else if (!genericType.equals(other.genericType))
			return false;
		if (!Arrays.equals(typeParameters, other.typeParameters))
			return false;
		return true;
	}

	public TDisjointUnion(TGenericType genericType, Object... typeParameters) {
		super(new TDUDelegate());
		this.genericType = genericType;
		this.typeParameters = typeParameters;
	}

	public String toString() {
		String string = this.genericType.name + (this.typeParameters.length==0?"":" of");
		for (Object p : this.typeParameters) {
			string += " " + p;
		}
		return string;
	}
}
