/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.type;

import java.util.ArrayList;
import java.util.List;

import jfp.datatype.Pair;
import jfp.dynamic.Term;
import jfp.dynamic.ASTException;
import jfp.dynamic.ExtensibleAST;
import jfp.dynamic.TypeASTDelegate;
import jfp.environment.TypeVariableEnvironmentInterface;

public class TFunctionDelegate extends TypeASTDelegate {

	@Override
	public Object unify_env(ExtensibleAST ast, TypeVariableEnvironmentInterface env,
			ExtensibleAST extensibleAST, TypeVariableEnvironmentInterface interface1)
			throws ASTException {
		TFunction funcType = (TFunction) ast;
		
		if (extensibleAST instanceof TFunction) {
			return Util.unifiable(((TFunction) funcType).getDomainType(), env,
					((TFunction) extensibleAST).getDomainType(), interface1)
					&& Util.unifiable(((TFunction) funcType).getRangeType(), env,
							((TFunction) extensibleAST).getRangeType(), interface1);
		}
		return false;
	}

	@Override
	public Object type_varaibles(ExtensibleAST ast, TypeVariableEnvironmentInterface env)
			throws ASTException {
		return null;
	}

	@Override
	public Object instantiate(ExtensibleAST value, TypeVariableEnvironmentInterface env)
			throws ASTException {
		return new TFunction(Util.getTypeInstance(((TFunction) value)
				.getDomainType(), env), Util.getTypeInstance(((TFunction) value)
				.getRangeType(), env));
	}


	@Override
	public Object inst(ExtensibleAST ast, TypeVariableEnvironmentInterface env) throws ASTException {
		return new TFunction(Util.wrap(((TFunction)ast).domainType).visitedBy(Term.INST, env),Util.wrap(((TFunction)ast).rangeType).visitedBy(Term.INST, env));
	}

}
