/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.type;

import java.util.ArrayList;
import java.util.List;

import jfp.dynamic.ExtensibleTypeAST;

public class TIntersection extends ExtensibleTypeAST {

	List<Object> list;


	
	public TIntersection(List<Object> list) {
		super(new TIntersectionDelegate());
		this.list = list;
	}

	public void addType(Object type) {
		list.add(type);
	}

	public void flattern() {
		List<TIntersection> remove = new ArrayList<TIntersection>();
		for (Object t : list) {
			if (t instanceof TIntersection) {
				remove.add((TIntersection) t);
			}
		}
		for (TIntersection t : remove) {
			list.remove(t);
			t.flattern();
			list.addAll(t.list);
		}

	}
	
	public String toString() {
		if(list.isEmpty())
			return "";
		String str = list.get(0).toString();
		for(int i =1;i<list.size();i++) {
			str += " & "+list.get(i);
		}
		return str;
	}

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((list == null) ? 0 : list.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null || getClass() != obj.getClass()
				|| !list.equals(((TIntersection) obj).list))
			return false;
		return true;
	}

	public List<Object> consists() {
		return list;
	}
}