/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.type;

import jfp.dynamic.ExtensibleTypeAST;

public class TList<U> extends ExtensibleTypeAST {
	
	private Object elt;

	public TList(Object elt) {
		super(new TListDelegate());
		this.elt = elt;
	}

	public Object getElementType() {
		return elt;
	}
	@Override
	public String toString() {
		return "["+this.elt.toString()+"]";
	}
	
	public boolean equals(Object type) {
		if(type instanceof TList) {
			TList n = (TList) type;
			return getElementType().equals(n.getElementType());
		}
		return false;
		
	}
	
	public int hashCode() {
		return this.toString().hashCode();
	}
}
