/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package jfp.type;

import jfp.dynamic.Term;
import jfp.dynamic.ASTException;
import jfp.dynamic.ExtensibleAST;
import jfp.dynamic.TypeASTDelegate;
import jfp.environment.TVarEnvironment;
import jfp.environment.TypeVariableEnvironmentInterface;

public class TUniversalDelegate extends TypeASTDelegate {


	@Override
	public Object instantiate(ExtensibleAST ast, TypeVariableEnvironmentInterface env)
			throws ASTException {
		TUniversal uni = (TUniversal) ast;
		TVarEnvironment e = new TVarEnvironment(env);
		for(TVar v : uni.var)
		e.bindType(v.getName(), v);
		return new TUniversal(uni.var, Util.wrap(uni.type).visitedBy(Term.INSTANTIATE, e));
	}

	@Override
	public Object type_varaibles(ExtensibleAST ast, TypeVariableEnvironmentInterface env)
			throws ASTException {
		return new TUniversal(((TUniversal) ast).var,
				((ExtensibleAST) ((TUniversal) ast).type).visitedBy(
						ExtensibleAST.TYPE_VARIABLES, env));
	}

	@Override
	public Object unify_env(ExtensibleAST ast, TypeVariableEnvironmentInterface env,
			ExtensibleAST extensibleAST, TypeVariableEnvironmentInterface interface1)
			throws ASTException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Object inst(ExtensibleAST ast, TypeVariableEnvironmentInterface env) throws ASTException {
		TVarEnvironment e = new TVarEnvironment(env);
		TUniversal uni = (TUniversal)ast;
		for(TVar v : (uni).var) {
			e.bindType(v.getName(), v);
		}
		return new TUniversal((uni).var,Util.wrap(uni.type).visitedBy(Term.INST, e));
	}

}
