/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.concurrent.data;

import java.util.Comparator;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import logic.data.Literal;
import logic.data.PrefixList;
import logic.syntax.TermParser;

public class LiteralComparator implements Comparator<Literal> {

    public static HashMap<Literal, Integer> groundUnitLiterals = new HashMap<Literal, Integer>();
    public static PrefixList prefixList;
    public static Set<Object> checkPoints = new HashSet<Object>();
    private static int id = 0;

    public static void initiatePrefixList() {
        prefixList = new PrefixList(TermParser.fsmap.size() + TermParser.psmap.size());
    }

    public static void addLiteral(Literal l) {
        if (prefixList.addNode(l)) {
            addGroundUnitLiterals(l);
            addGroundUnitLiterals(l.negate());
            checkPoints.clear();
        }
    }

    public static void addCheckPoint(Object o) {
        checkPoints.add(o);
    }

    public static boolean hasCheckPoint(Object o) {
        return checkPoints.contains(o);
    }

    public static void addGroundUnitLiterals(Literal l) {
        groundUnitLiterals.put(l, id++);
    }

    public int compare(Literal arg0, Literal arg1) {

        int[] k0 = arg0.getKey();
        int[] k1 = arg1.getKey();
        int n = k0.length;
        int n1 = k1.length;
        if (n < n1) {
            return -1;
        }
        if (n > n1) {
            return 1;
        }
        for (int i = 0; i < n; i++) {
            if (k0[i] < k1[i]) {
                return -1;
            }
            if (k0[i] > k1[i]) {
                return 1;
            }
        }

        return 0;
    }
}
