/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.concurrent.data;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

import logic.data.Term;

public class TermTypedListML implements List<Term> {

    private int max;
    TermTypedIterator ti;

    public TermTypedListML(int max, String type) {
        super();
        this.max = max;
        this.type = type;
        ti = new TermTypedIterator(max, type);

    }

    public boolean add(Term arg0) {
        throw new UnsupportedOperationException();
    }

    public void add(int arg0, Term arg1) {
        throw new UnsupportedOperationException();

    }

    public boolean addAll(Collection<? extends Term> arg0) {
        throw new UnsupportedOperationException();
    }

    public boolean addAll(int arg0, Collection<? extends Term> arg1) {
        throw new UnsupportedOperationException();
    }

    public void clear() {
        throw new UnsupportedOperationException();

    }

    public boolean contains(Object arg0) {
        throw new UnsupportedOperationException();
    }

    public boolean containsAll(Collection<?> arg0) {
        throw new UnsupportedOperationException();
    }

    public Term get(int arg0) {
        throw new UnsupportedOperationException();
    }

    public int indexOf(Object arg0) {
        throw new UnsupportedOperationException();
    }

    public boolean isEmpty() {
        return TermIterator.getFs().isEmpty();
    }
    public String type;

    public Iterator<Term> iterator() {
        return new ResettableTermIterator();
    }
    
    public Iterator<Term> mlIterator() {
        return new MLTermIterator();
    }

    public class ResettableTermIterator implements Iterator<Term> {

        TermTypedIterator ti = new TermTypedIterator(max, type);
        Term next = null;

        public boolean hasNext() {
            if (next == null) {
                next = ti.next_term();
            }
            return next != null;
        }

        public Term next() {

            if (next == null) {
                next = ti.next_term();
            }
            Term ot = next;
            next = null;
            return ot;

        }

        public void remove() {
            throw new UnsupportedOperationException();
        }

        public void reset() {
            this.ti = new TermTypedIterator(max, type);
            next = null;
        }
    }

    public class MLTermIterator extends ResettableTermIterator {

        TermTypedIterator ti = new TermTypedIterator(max, type);
        Term next = null;

        public boolean hasNext() {
            if (next == null) {
                next = ti.next_ml();
            }
            return next != null;
        }

        public Term next() {

            if (next == null) {
                next = ti.next_term();
            }
            Term ot = next;
            next = null;
            return ot;

        }

        public void remove() {
            throw new UnsupportedOperationException();
        }

        public void reset() {
            this.ti = new TermTypedIterator(max, type);
            next = null;
        }
    }

    public int lastIndexOf(Object arg0) {
        throw new UnsupportedOperationException();
    }

    public ListIterator<Term> listIterator() {
        throw new UnsupportedOperationException();
    }

    public ListIterator<Term> listIterator(int arg0) {
        throw new UnsupportedOperationException();
    }

    public boolean remove(Object arg0) {
        throw new UnsupportedOperationException();
    }

    public Term remove(int arg0) {
        throw new UnsupportedOperationException();
    }

    public boolean removeAll(Collection<?> arg0) {
        throw new UnsupportedOperationException();
    }

    public boolean retainAll(Collection<?> arg0) {
        throw new UnsupportedOperationException();
    }

    public Term set(int arg0, Term arg1) {
        throw new UnsupportedOperationException();
    }

    public int size() {
        if (this.isEmpty()) {
            return 0;
        } else {
            return 1;
        } // TODO return the correct value
    }

    public List<Term> subList(int arg0, int arg1) {
        throw new UnsupportedOperationException();
    }

    public Object[] toArray() {
        throw new UnsupportedOperationException();
    }

    public <T> T[] toArray(T[] arg0) {
        throw new UnsupportedOperationException();
    }
}
