/*
 Copyright 2006, 2007, 2008 Hao Xu
 ertranne@hotmail.com
 
 This file is part of OSHL-S.

 OSHL-S is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 OSHL-S is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Foobar; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package logic.concurrent.function;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import concurrent.AbstractAnalyzerTaskFactory;
import concurrent.SearchFailureException;
import concurrent.Task;
import concurrent.Task.TaskInstance;

public class EnumerationProcedure<T> extends
		AbstractAnalyzerTaskFactory<List<T>, T> {

	@Override
	public Task<List<T>, T> create() {
		return new Task<List<T>, T>() {
			Collection<? extends T> collection;

			Iterator<? extends T> k;

			public boolean hasNext() {
				return k.hasNext();
			}

			public boolean input(List<T> input) {
				collection = input;
				k = collection.iterator();
				return false;
			}

			public concurrent.Task.TaskInstance<T> next() {
				return new Task.TaskInstance<T>() {

					public T run() throws SearchFailureException {
						return k.next();
					}
				};
			}

		};
	}

}
